package org.eso.oca.backend;

import org.eso.oca.fits.OCAFile;

/**
 * Container class to store the result of a "select associate"
 * query within an action rule. 
 * 
 * @author szampier
 *
 */
public class SelectionBlock {

	/** The selected files. */
    final OCAFile[] selectedFiles;

    /** Minumum number of results as specified in the OCA rules. */
    final int minRet;
	
    /** Maximum number of results as specified in the OCA rules. */
	final int maxRet;
	
	/** The result type. */
	final String alias;

	/**
	 * Constructor.
	 * @param alias
	 * @param minRet
	 * @param maxRet
	 * @param selectedFiles
	 */
	public SelectionBlock(String alias, int minRet, int maxRet,
			OCAFile[] selectedFiles) {
		this.alias = alias;
		this.minRet = minRet;
		this.maxRet = maxRet;
		this.selectedFiles = selectedFiles;
	}

	public String getAlias() {
		return alias;
	}

	public int getMaxRet() {
		return maxRet;
	}

	public int getMinRet() {
		return minRet;
	}

	public OCAFile[] getSelectedFiles() {
		return selectedFiles;
	}
}
