package org.eso.oca.dal;

/**
 * This class contains information about one column of an Instrument Specific Table (IST),
 * as stored in table meta_columns.
 * 
 * @author szampier
 *
 */
public class MetaColumn {
	/** The line separator. */
	static final String EOL = System.getProperty("line.separator");
	
	/** The table name. */
	private String tname;
	
	/** The column name. */
	private String name;
	
	/** The column type. */
	private String type;
	
	/** The column lenght. */
	private int length;
	
	/** The keyword name. */
	private String keyword;

	/**
	 * Returns a string representation of this object.
	 */
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("[ColumnName=" + name);
		buf.append("; ColumnType=" + type);
		buf.append("; ColumnLength=" + length);
		buf.append("; Keyword=" + keyword);
		buf.append("]");

		return buf.toString();
	}

	// Getters and setters
	public String getKeyword() {
		return keyword;
	}

	public void setKeyword(String keyword) {
		this.keyword = keyword;
	}

	public int getLength() {
		return length;
	}

	public void setLength(int length) {
		this.length = length;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getTname() {
		return tname;
	}

	public void setTname(String tname) {
		this.tname = tname;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
}
