package org.eso.oca.dal;

/**
 * This class contains information about an Instrument Specific Table (IST),
 * as stored in meta_tables and meta_columns.
 * 
 * @author szampier
 *
 */
public class MetaTable {
	/** The line separator. */
	static final String EOL = System.getProperty("line.separator");

	/** The meta-columns. */
	private MetaColumn[] metaColumns;
	
	/** The table name. */
	private String name;
	
	/** The instrument name. */
	private String instrume;

	/**
	 * Returns a string representation of this object.
	 */
	public String toString() {
		StringBuffer buf = new StringBuffer();
		
		buf.append("[TableName=");
		buf.append(name);
		buf.append("; Instrument=");
		buf.append(instrume);
		buf.append("]");
		buf.append(EOL);
		
		for (int i = 0; i < metaColumns.length; ++i) {
			buf.append(metaColumns[i].toString());
			buf.append(EOL);
		}

		return buf.toString();
	}

	// Getters and setters
	public MetaColumn[] getMetaColumns() {
		return metaColumns;
	}

	public void setMetaColumns(MetaColumn[] metaColumns) {
		this.metaColumns = metaColumns;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getInstrume() {
		return instrume;
	}

	public void setInstrume(String instrume) {
		this.instrume = instrume;
	}
}
