package org.eso.oca.data;

import java.sql.SQLException;

/**
 * Interface CalibColumnsListener
 * 
 * Listener that is notified of calib_columns table changes.
 *
 * @version $Revision: 1.4 $
 * @author pnunes, Mar 30, 2005
 */

public interface CalibColumnsListener {
    
    /**
     * Invoked just before inserting a CalibColumnsBean record into the database.
     *
     * @param pObject the CalibColumnsBean that is about to be inserted
     */
    public void beforeInsert(MetaColumn pObject) throws SQLException;


    /**
     * Invoked just after a CalibColumnsBean record is inserted in the database.
     *
     * @param pObject the CalibColumnsBean that was just inserted
     */
    public void afterInsert(MetaColumn pObject) throws SQLException;


    /**
     * Invoked just before updating a CalibColumnsBean record in the database.
     *
     * @param pObject the CalibColumnsBean that is about to be updated
     */
    public void beforeUpdate(MetaColumn pObject) throws SQLException;


    /**
     * Invoked just after updating a CalibColumnsBean record in the database.
     *
     * @param pObject the CalibColumnsBean that was just updated
     */
    public void afterUpdate(MetaColumn pObject) throws SQLException;
 
}
