package org.eso.oca.data;

import java.sql.SQLException;

/**
 * Interface ObsTablesListener
 * 
 * Listener that is notified of obs_tables table changes.
 *
 * @version $Revision: 1.4 $
 * @author pnunes, Mar 30, 2005
 */


public interface ObsTablesListener {
    /**
     * Invoked just before inserting a ObsTablesBean record into the database.
     *
     * @param pObject the ObsTablesBean that is about to be inserted
     */
    public void beforeInsert(MetaTable pObject) throws SQLException;


    /**
     * Invoked just after a ObsTablesBean record is inserted in the database.
     *
     * @param pObject the ObsTablesBean that was just inserted
     */
    public void afterInsert(MetaTable pObject) throws SQLException;


    /**
     * Invoked just before updating a ObsTablesBean record in the database.
     *
     * @param pObject the ObsTablesBean that is about to be updated
     */
    public void beforeUpdate(MetaTable pObject) throws SQLException;


    /**
     * Invoked just after updating a ObsTablesBean record in the database.
     *
     * @param pObject the ObsTablesBean that was just updated
     */
    public void afterUpdate(MetaTable pObject) throws SQLException;

}
