package org.eso.oca.fits;

import java.lang.String;
import java.lang.Exception;

/** This exception is thrown by file handlers if a problem occurs whilst 
 * working with a file. 
 *
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class FileHandlerException extends Exception
{
    /** Creates a FileHandlerException with no detail message or cause. */
    public FileHandlerException()
    {
        super();
    }

    /** Creates a FileHandlerException with the specified detail message. 
     * 
     * @param message a detail message for this exception. 
     */
    public FileHandlerException(String message)
    {
        super(message);
    }

    /** Creates a FileHandlerException with the specified detail message 
     * and cause. 
     *
     * @param message a detail message for this exception. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public FileHandlerException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates a FileHandlerException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public FileHandlerException(Throwable cause)
    {
        super(cause);
    }
}
