package org.eso.oca.fits;

import org.apache.log4j.Logger;

/** Instances of this class represent undefined FITS values. 
 *
 * @see TypedHeaderCard
 * @see TypedHeaderCard#UNDEFINED
 * 
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class UndefinedFITSValue
{
    /** Apache Log4J logger. */ 
    static final Logger logger = Logger.getLogger(UndefinedFITSValue.class); 

    /** A string representation for instances of this class. */ 
    static final String UNDEFINED = "UNDEFINED"; 

    /** Constructs a new UndefinedFITSValue. */ 
    public UndefinedFITSValue()
    {
        logger.trace("UndefinedFITSValue::UndefinedFITSValue()"); 
    }

    /** Undefined values are never equal to anything, so this method always 
     * returns false. 
     */
    public boolean equals(Object obj)
    {
        logger.trace("UndefinedFITSValue::equals()"); 

        return(false); 
    }

    /** This method always returns the string "{@value #UNDEFINED}". */ 
    public String toString()
    {
        logger.trace("UndefinedFITSValue::toString()"); 

        return(UNDEFINED); 
    }
}
