package org.eso.oca.fits;

import org.apache.log4j.Logger;

/** Instances of this class represent untyped FITS values. 
 * 
 * @see TypedHeaderCard
 * @see TypedHeaderCard#UNTYPED
 * 
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class UntypedFITSValue
{
    /** Apache Log4J logger. */ 
    static final Logger logger = Logger.getLogger(UntypedFITSValue.class); 

    /** A string representation for instances of this class. */ 
    static final String UNTYPED = "UNTYPED"; 

    /** Constructs a new UntypedFITSValue. */ 
    public UntypedFITSValue()
    {
        logger.trace("UntypedFITSValue::UntypedFITSValue()"); 
    }

    /** Untyped values are never equal to anything, so this method always 
     * returns false. 
     */
    public boolean equals(Object obj)
    {
        logger.trace("UntypedFITSValue::equals()"); 

        return(false); 
    }

    /** This method always returns the string "{@value #UNTYPED}". */ 
    public String toString()
    {
        logger.trace("UntypedFITSValue::toString()"); 

        return(UNTYPED); 
    }
}
