package org.eso.oca.fitsmapper;

import java.sql.SQLException;
import java.util.Hashtable;

import org.eso.oca.data.JdbcConnectionException;

/**
 * Class MemDbFitsMapper
 *
 *  Implements the DBFitsMapper  without loading from the database
 *  It is meant to be updated dinamically
 *
 * @version $Revision: 1.3 $
 * @author pnunes, Apr 21, 2005
 */

// $Id: MemDbFitsMapper.java,v 1.3 2005/06/06 10:31:20 szampier Exp $ 
public class MemDbFitsMapper extends DbFitsMapper {
    
    /**
     * Singleton
     */
    private static MemDbFitsMapper _instance; 

    
    // For lazy initialization 
    public static synchronized MemDbFitsMapper getInstance() throws SQLException, JdbcConnectionException { 
       if (_instance==null) { 
          _instance = new MemDbFitsMapper(); 
         } 
         return _instance; 
    }    
            
    private MemDbFitsMapper() {        
        tables = new Hashtable();
        columnsFromKW = new Hashtable();
        columnsFromColumnName = new Hashtable(); 
    }
    
    
    
    
}





