package org.eso.util.configuration; 

/** This error is thrown by {@link Configuration} or {@link MetaConfigurator} 
 * methods when an application cannot be meta-configured. 
 * 
 * @author Neil Ferguson ESO/SDD/DFI/BET <nferguso@eso.org> 
 */
public class MetaConfigurationError extends Error 
{
    /** Creates a MetaConfigurationError with no detail message or cause. */ 
    public MetaConfigurationError() 
    {
        super(); 
    }

    /** Creates a MetaConfigurationError with the specified detail message. 
     * 
     * @param message a detail message for this error. 
     */
    public MetaConfigurationError(String message) 
    {
        super(message); 
    }

    /** Creates a MetaConfigurationError with the specified detail message 
     * and cause. 
     * 
     * @param message a detail message for this error. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this error. 
     */
    public MetaConfigurationError(String message, Throwable cause) 
    {
        super(message, cause); 
    }

    /** Creates a MetaConfigurationError with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this error. 
     */
    public MetaConfigurationError(Throwable cause) 
    {
        super(cause); 
    }
}
