package org.eso.util.dal;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.log4j.Logger;

public class DataProductsDAOSyb implements DataProductsDAO {
	
	/** Apache Log4J logger. */
    static final Logger logger = Logger.getLogger(DataProductsDAOSyb.class);
    
    /** The name of this class for logging purposes. */
	private static final String classLogName = "DataProductsDAOSyb";
	
	/* table columns */
	public static final String CDBFILE_KW = "cdbfile";
	public static final String DPID_KW = "dp_id";
	
    /** database's connection parameters */
    private String d_dbUrl			= null;
    private String d_dbUsername		= null;
    private String d_dbPassword		= null;
    
    /** db table */
    private String d_dbTable		= null;
    
    public DataProductsDAOSyb(String dbUrl, String dbUsername, String dbPassword, String dbTable) {
		d_dbUrl			= dbUrl;
		d_dbUsername	= dbUsername;
		d_dbPassword	= dbPassword;
		d_dbTable		= dbTable;
	}
	
	public String getCdbFile(String dpId) throws DAOException {
		String query = "SELECT " + CDBFILE_KW + " FROM " + d_dbTable + " WHERE " + DPID_KW + "='" + dpId + "'";
		return executeQuery(query, CDBFILE_KW);
	}
	
	public String getDpId(String cdbfile) throws DAOException {
		String query = "SELECT " + DPID_KW + " FROM " + d_dbTable + " WHERE " + CDBFILE_KW + "='" + cdbfile + "'";
		return executeQuery(query, DPID_KW);
	}
	
	/* TODO add test */
	public boolean findDpId(String dpId) throws DAOException {
		String query = "SELECT " + DPID_KW + " FROM " + d_dbTable + " WHERE " + DPID_KW + "='" + dpId + "'";
		return (executeQuery(query, DPID_KW) != null);
	}
	
	private String executeQuery(String query, String field) throws DAOException {
		try {
			Connection conn = SybaseConnectionService.getConnection(d_dbUrl, d_dbUsername, d_dbPassword); 
			ResultSet rs = SybaseConnectionService.executeStatement(conn, query);
			String result = null;
			if (rs.next())
				result = rs.getString(field);
			SybaseConnectionService.closeConnection(conn);
			return result;
		} catch (ConnectionServiceException e) {
			throw new DAOException(e.getMessage());
		} catch (SQLException e) {
			throw new DAOException(e.getMessage());
		}
	}
	
	public static void main(String[] args) {
		
	}
}
