package org.eso.util.dal;

import java.sql.Connection;
//import java.util.List;

import org.apache.log4j.Logger;

/**
 * Sybase implementation of the MdFile DAO
 * 
 * @author Vincenzo Forchi` <vforchi@eso.org>
 *
 */
public class MdFileDAOSyb implements MdFileDAO {
	
	/** Apache Log4J logger. */
    static final Logger logger = Logger.getLogger(MdFileDAOSyb.class);
    
    /** database's connection parameters */
    private String d_dbUrl			= null;
    private String d_dbUsername		= null;
    private String d_dbPassword		= null;
    
    /** mdfiles table */
    private String d_dbTable		= null;
    
    private Connection d_connection	= null;
    
	public MdFileDAOSyb(String dbUrl, String dbUsername, String dbPassword, String dbTable) {
		d_dbUrl			= dbUrl;
		d_dbUsername	= dbUsername;
		d_dbPassword	= dbPassword;
		d_dbTable		= dbTable;
	}
	
	public MdFileDAOSyb(Connection connection, String dbTable, String dbFilesTable) {
		d_connection	= connection;
		d_dbTable		= dbTable;
	}

	public int deleteByDiskNameAndFileId(String name, String fileId) throws DAOException {
		String query = "delete from " + d_dbTable + " where diskname='" + name + "' and file_id = '" + fileId + "'";
		return executeQuery(query);
	}
	
	/**
	 * Convenience method used for database access
	 * @param query
	 * @throws DAOException
	 */
	private int executeQuery(String query) throws DAOException {
		try {
			int res;
			if (d_connection == null)
			{
				Connection conn = SybaseConnectionService.getConnection(d_dbUrl, d_dbUsername, d_dbPassword); 
				res = SybaseConnectionService.executeUpdateStatement(conn, query);
				SybaseConnectionService.closeConnection(conn);
			}
			else
				res = SybaseConnectionService.executeUpdateStatement(d_connection, query);
			return res;
		} catch (ConnectionServiceException e) {
			throw new DAOException(e.getMessage());
		}
	}
	
	public static void main(String[] args) {
		MdFileDAO dao = new MdFileDAOSyb("acdbdev.hq.eso.org:6789", "frameingest", "frameingest", "tempdb..mdfiles");
		try {
			dao.deleteByDiskNameAndFileId("diskname","file_id");
		} catch (DAOException e) {
			System.out.println(e.getMessage());
		}
	}
}
	
