package org.eso.util.dal;

import java.sql.Date;
import java.util.ArrayList;
import java.util.List;
import java.math.BigDecimal;

/**
 * This class maps a record of the ngas_disks table
 * 
 * @author Vincenzo Forchi` <vforchi@eso.org>
 *
 */

public class NgasDisk {

	/* private data */
	private String		disk_id					= null;
	private String		archive					= null;
	private Date		installation_date		= null;
	private String		type					= null;
	private String		manufacturer			= null;
	private String		logical_name			= null;
	private String		host_id					= null;
	private String		slot_id					= null;
	private Short		mounted					= null;
	private String		mount_point				= null;
	private Integer		number_of_files			= null;
	private Integer		available_mb			= null;
	private BigDecimal	bytes_stored			= null;
	private Short		completed				= null;
	private Date		completion_date			= null;
	private String		checksum				= null;
	private Float		total_disk_write_time	= null;
	private Date		last_check				= null;
	private String		last_host_id			= null;
	
	private static Integer		d_numFields		= 19;
	private static List<String> d_fieldNames	= new ArrayList<String>();
	
	static {
		d_fieldNames.add(0, "disk_id");
		d_fieldNames.add(1, "archive");
		d_fieldNames.add(2, "installation_date");
		d_fieldNames.add(3, "type");
		d_fieldNames.add(4, "manufacturer");
		d_fieldNames.add(5, "logical_name");
		d_fieldNames.add(6, "host_id");
		d_fieldNames.add(7, "slot_id");
		d_fieldNames.add(8, "mounted");
		d_fieldNames.add(9, "mount_point");
		d_fieldNames.add(10, "number_of_files");
		d_fieldNames.add(11, "available_mb");
		d_fieldNames.add(12, "bytes_stored");
		d_fieldNames.add(13, "completed");
		d_fieldNames.add(14, "completion_date");
		d_fieldNames.add(15, "checksum");
		d_fieldNames.add(16, "total_disk_write_time");
		d_fieldNames.add(17, "last_check");
		d_fieldNames.add(18, "last_host_id");
	}
	
	public String getDiskId() {
		return disk_id;
	}
	public void setDiskId(String disk_id) {
		this.disk_id = disk_id;
	}
	public String getArchive() {
		return archive;
	}
	public void setArchive(String archive) {
		this.archive = archive;
	}
	public Date getInstallationDate() {
		return installation_date;
	}
	public void setInstallationDate(Date installation_date) {
		this.installation_date = installation_date;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public String getManufacturer() {
		return manufacturer;
	}
	public void setManufacturer(String manufacturer) {
		this.manufacturer = manufacturer;
	}
	public String getLogicalName() {
		return logical_name;
	}
	public void setLogicalName(String logical_name) {
		this.logical_name = logical_name;
	}
	public String getHostId() {
		return host_id;
	}
	public void setHostId(String host_id) {
		this.host_id = host_id;
	}
	public String getSlotId() {
		return slot_id;
	}
	public void setSlotId(String slot_id) {
		this.slot_id = slot_id;
	}
	public Short getMounted() {
		return mounted;
	}
	public void setMounted(short mounted) {
		this.mounted = mounted;
	}
	public String getMountPoint() {
		return mount_point;
	}
	public void setMountPoint(String mount_point) {
		this.mount_point = mount_point;
	}
	public Integer getNumberOfFiles() {
		return number_of_files;
	}
	public void setNumberOfFiles(int number_of_files) {
		this.number_of_files = number_of_files;
	}
	public Integer getAvailableMb() {
		return available_mb;
	}
	public void setAvailableMb(int available_mb) {
		this.available_mb = available_mb;
	}
	public BigDecimal getBytesStored() {
		return bytes_stored;
	}
	public void setBytesStored(BigDecimal bytes_stored) {
		this.bytes_stored = bytes_stored;
	}
	public Short getCompleted() {
		return completed;
	}
	public void setCompleted(short completed) {
		this.completed = completed;
	}
	public Date getCompletionDate() {
		return completion_date;
	}
	public void setCompletionDate(Date completion_date) {
		this.completion_date = completion_date;
	}
	public String getChecksum() {
		return checksum;
	}
	public void setChecksum(String checksum) {
		this.checksum = checksum;
	}
	public Float getTotalDiskWriteTime() {
		return total_disk_write_time;
	}
	public void setTotalDiskWriteTime(float total_disk_write_time) {
		this.total_disk_write_time = total_disk_write_time;
	}
	public Date getLastCheck() {
		return last_check;
	}
	public void setLastCheck(Date last_check) {
		this.last_check = last_check;
	}
	public String getLastHostId() {
		return last_host_id;
	}
	public void setLastHostId(String last_host_id) {
		this.last_host_id = last_host_id;
	}
	
	@Override
	public String toString() {
		int i = 0;
		String res = "NgasDisk instance (*=mandatory): ";
		res += "\n" + i++ + "\tdisk_id " + disk_id + "*";
		res += "\n" + i++ + "\tarchive " + archive + "*";
		res += "\n" + i++ + "\tinstallation_date " + installation_date + "*";
		res += "\n" + i++ + "\ttype " + type + "*";
		res += "\n" + i++ + "\tmanufacturer " + manufacturer;
		res += "\n" + i++ + "\tlogical_name " + logical_name + "*";
		res += "\n" + i++ + "\thost_id " + host_id;
		res += "\n" + i++ + "\tslot_id " + slot_id;
		res += "\n" + i++ + "\tmounted " + mounted;
		res += "\n" + i++ + "\tmount_point " + mount_point;
		res += "\n" + i++ + "\tnumber_of_files " + number_of_files + "*";
		res += "\n" + i++ + "\tavailable_mb " + available_mb + "*";
		res += "\n" + i++ + "\tbytes_stored " + bytes_stored + "*";
		res += "\n" + i++ + "\tcompleted " + completed + "*";
		res += "\n" + i++ + "\tcompletion_date " + completion_date;
		res += "\n" + i++ + "\tchecksum " + checksum;
		res += "\n" + i++ + "\ttotal_disk_write_time " + total_disk_write_time;
		res += "\n" + i++ + "\tlast_check " + last_check;
		res += "\n" + i++ + "\tlast_host_id " + last_host_id;
		
		return res;
	}
	
	/**
	 * Checks an NgasDisk instance for mandatory fields
	 * 
	 * @param disk the instance to be checked
	 * @throws DAOException if there are some missing fields
	 */
	public static void validate(NgasDisk disk) throws DAOException {
		String fields = "";
		if (disk.getDiskId() == null)
			fields += ", disk_id";
		if (disk.getArchive() == null)
			fields += ", archive";
		if (disk.getInstallationDate() == null)
			fields += ", installation date";
		if (disk.getType() == null)
			fields += ", type";
		if (disk.getLogicalName() == null)
			fields += ", logical_name";
		if (disk.getNumberOfFiles() == null)
			fields += ", number_of_files";
		if (disk.getAvailableMb() == null)
			fields += ", available_mb";
		if (disk.getBytesStored() == null)
			fields += ", bytes_stored";
		if (disk.getCompleted() == null)
			fields += ", completed";
		
		if (fields.length() > 0)
			throw new DAOException("Mandatory field(s) " + fields.substring(2) + " missing");	
	}

	/**
	 * Returns the given field as a String
	 * @param field the index of the desired field
	 * @return the value converted to String
	 */
	public String getFieldAsString(int field) throws DAOException {
		String ret = null;
		try {
			switch (field) {
			case 0:
				ret = getDiskId();
				break;
			case 1:
				ret = getArchive();
				break;
			case 2:
				ret = getInstallationDate().toString();
				break;
			case 3:
				ret = getType();
				break;
			case 4:
				ret = getManufacturer();
				break;
			case 5:
				ret = getLogicalName();
				break;
			case 6:
				ret = getHostId();
				break;
			case 7:
				ret = getSlotId();
				break;
			case 8:
				ret = getMounted().toString();
				break;
			case 9:
				ret = getMountPoint();
				break;
			case 10:
				ret = getNumberOfFiles().toString();
				break;
			case 11:
				ret = getAvailableMb().toString();
				break;
			case 12:
				ret = getBytesStored().toString();
				break;
			case 13:
				ret = getCompleted().toString();
				break;
			case 14:
				ret = getCompletionDate().toString();
				break;
			case 15:
				ret = getChecksum();
				break;
			case 16:
				ret = getTotalDiskWriteTime().toString();
				break;
			case 17:
				ret = getLastCheck().toString();
				break;
			case 18:
				ret = getLastHostId();
				break;
			default:
				throw new DAOException(field + " out of range");
			}
		} catch (NullPointerException e) {
			
		}

		return ret;
	}
	
	/**
	 * Returns the given field as a String
	 * @param field the name of the desired field
	 * @return the value converted to String
	 */
	public String getFieldAsString(String field) throws DAOException {
		if (d_fieldNames.contains(field) == true)
			return getFieldAsString(d_fieldNames.indexOf(field));
		else
			return null;
	}

	/**
	 * Sets a field starting from a string, regardless data type
	 * @param field the index of the field to be set
	 * @param value the value to be set
	 */
	public void setFieldFromString(int field, String value) throws DAOException {
		if ((value == null) || (value.length() == 0))
			return;
		
		try {
			switch (field) {
			case 0:
				setDiskId(value);
				break;
			case 1:
				setArchive(value);
				break;
			case 2:
				setInstallationDate(Date.valueOf(value));
				break;
			case 3:
				setType(value);
				break;
			case 4:
				setManufacturer(value);
				break;
			case 5:
				setLogicalName(value);
				break;
			case 6:
				setHostId(value);
				break;
			case 7:
				setSlotId(value);
				break;
			case 8:
				setMounted(Short.valueOf(value));
				break;
			case 9:
				setMountPoint(value);
				break;
			case 10:
				setNumberOfFiles(Integer.valueOf(value));
				break;
			case 11:
				setAvailableMb(Integer.valueOf(value));
				break;
			case 12:
				setBytesStored(BigDecimal.valueOf(Double.valueOf(value)));
				break;
			case 13:
				setCompleted(Short.valueOf(value));
				break;
			case 14:
				setCompletionDate(Date.valueOf(value));
				break;
			case 15:
				setChecksum(value);
				break;
			case 16:
				setTotalDiskWriteTime(Float.valueOf(value));
				break;
			case 17:
				setLastCheck(Date.valueOf(value));
				break;
			case 18:
				setLastHostId(value);
				break;
			default:
				throw new DAOException(field + " out of range");
			}
		} catch (NullPointerException e) {}
	}
	
	/**
	 * Sets a field starting from a string, regardless data type
	 * @param field the name of the field to be set
	 * @param value the value to be set
	 */
	public void setFieldFromString(String field, String value) throws DAOException {
		if (d_fieldNames.contains(field) == true)
			setFieldFromString(d_fieldNames.indexOf(field), value);
		else 
			throw new DAOException(field + " is not a valid NgasDisk's field");
	}
			
	public static String getFieldName(int field) throws DAOException {
		if (d_fieldNames.size() > field)
			return d_fieldNames.get(field);
		else
			throw new DAOException(field + " out of range");
	}
	
	public static List<String> getFieldNames() {
		return d_fieldNames;
	}
	
	public static Integer numFields() {
		return d_numFields;
	}
}
