package org.eso.util.dal;

import java.sql.Date;

/**
 * This class maps a record of the NgasFileSafe table.
 * 
 * @author Vincenzo Forchi` <vforchi@eso.org>
 */
public class NgasFileSafe {

	private String 	fileId			= null;
	private Integer	fileVersion 	= null;
	private Date 	ingestionDate 	= null;

	public String getFileId() {
		return fileId;
	}

	public void setFileId(String fileId) {
		this.fileId = fileId;
	}

	public Date getIngestionDate() {
		return ingestionDate;
	}

	public void setIngestionDate(Date ingestionDate) {
		this.ingestionDate = ingestionDate;
	}

	public Integer getFileVersion() {
		return fileVersion;
	}

	public void setFileVersion(Integer fileVersion) {
		this.fileVersion = fileVersion;
	}
	
	@Override
	public String toString() {
		
		return	"FileId = " +  getFileId() + ", " +
				"IngestionDate = " +  getIngestionDate() + ", " +
				"FileVersion = " +  getFileVersion();
	}
	
	/**
	 * Returns true if this instance is valid (i.e.: if all parameters that
	 * cannot be null have been initialized). 
	 * @return True if this instance is valid.
	 */
	public boolean isValid() {
		return 	getFileId() != null &&
				getIngestionDate() != null &&
				getFileVersion() != null;
	}
}
