package org.eso.util.dal;

import java.util.Comparator;

import org.apache.log4j.Logger;

/**
 * Implements the Comparator interface to compare replication requests according to
 * their priority and submission time.
 * 
 * @author vforchi
 * 
 */
public class ReplicationRequestComparator implements Comparator<ReplicationRequest> {

	/** The name of this class for logging purposes. */
	static final String classLogName = "ReplicationRequestComparator";

	/** Apache Log4J logger. */
	static final Logger logger = Logger.getLogger(ReplicationRequestComparator.class);

	public int compare(ReplicationRequest leftObj, ReplicationRequest rightObj) {
		final String methodLogName = classLogName + "::compare()";
		logger.trace(methodLogName);
		
		Integer res = 0;
		Integer tp1 = leftObj.getPriority();
		Integer tp2 = rightObj.getPriority();
		
		if ((tp1 != null) && (tp2 != null)) {
			res = tp1.compareTo(tp2);
			if (res == 0)
			{
				Long ct1 = leftObj.getSubmissionTime().getTime();
				Long ct2 = rightObj.getSubmissionTime().getTime();
				if ((ct1 != null) && (ct2 != null))
					res = ct1.compareTo(ct2);
			}
		}
		return res;
	}
}
