package org.eso.util.dal;

import java.util.Comparator;

import org.apache.log4j.Logger;
import org.eso.util.dal.TransferRequest;

/**
 * Implements the Comparator interface to compare transfer requests according to
 * their priority.
 * 
 * @author szampier
 * 
 */
public class TransferRequestComparator implements Comparator<TransferRequest> {

	/** The name of this class for logging purposes. */
	static final String classLogName = "TransferRequestPriorityComparator";

	/** Apache Log4J logger. */
	static final Logger logger = Logger.getLogger(TransferRequestComparator.class);

	public int compare(TransferRequest leftObj, TransferRequest rightObj) {
		final String methodLogName = classLogName + "::compare()";
		logger.trace(methodLogName);
		
		Integer res = 0;
		Integer tp1 = leftObj.getTransferPriority();
		Integer tp2 = rightObj.getTransferPriority();
		
		if ((tp1 != null) && (tp2 != null)) {
			res = tp1.compareTo(tp2);
			if (res == 0)
			{
				Long ct1 = leftObj.getCreationTime();
				Long ct2 = rightObj.getCreationTime();
				if ((ct1 != null) && (ct2 != null))
					res = ct1.compareTo(ct2);
			}
		}
		return res;
	}
}
