package org.eso.util.datatransfer;

import org.apache.log4j.Logger;

/**
 * Implementation of a command to load a file in a database table 
 * @author cmoins
 */
public class LoadDBTableCommand extends ShellCommand {
    /** Apache Log4J logger. */
    static final Logger logger = Logger.getLogger(UnpackCommand.class);

    private final String FILENAME_KEYWORD = "\\$FILENAME";

    private final String DB_TABLE_KEYWORD = "\\$DBTABLE";

    /**
     * Constructor
     * 
     * @param loadDBTableCmdFormat
     *            format of the command to load a file into a database table
     * @param filename
     *            file to load
     * @param dbTable
     *            name of the database table
     */
    public LoadDBTableCommand(String loadDBTableCmdFormat, String filename,
            String dbTable) {
        super(loadDBTableCmdFormat);
        command = command.replaceAll(FILENAME_KEYWORD, filename);
        command = command.replaceAll(DB_TABLE_KEYWORD, dbTable);
    }
}
