package org.eso.util.datatransfer;

import java.sql.ResultSet;
import org.apache.log4j.Logger;

public class NgasFileDAO {

    /** Apache Log4J logger. */
    static final Logger logger = Logger.getLogger(NgasFileDAO.class);
	
	private String tableName;
	private SybaseConnectionService archiveService = null;
	
	/**
	 * Constructor.
	 * 
	 * @param tableName name of the table to work with.
	 */
	public NgasFileDAO(String tableName, SybaseConnectionService archiveService) {
		this.tableName = tableName;
		this.archiveService = archiveService;
	}

	/**
	 * Inserts the NgasFile object into the DB.
	 * @param ngasFile The NgasFile to be inserted.
	 * @return The number of affected rows or -1 in case of error.
	 */
	public int insert(NgasFile ngasFile) {
		
		String logHead = "NgasFileDAO::insert() - ";

		int affectedRows = -1;
		
		String query = "insert into " + tableName + " (disk_id,file_name,file_id,format,file_size,uncompressed_file_size,compression,ingestion_date,ignore,checksum,checksum_plugin,file_version,file_status,creation_date) " +
					   "values ('" + 
					   ngasFile.getDiskId() + "','" +
					   ngasFile.getFileName() +"','" +
					   ngasFile.getFileId() + "','" +
					   ngasFile.getFormat() + "'," +
					   ngasFile.getFileSize() + "," +
					   ngasFile.getUncompressedFileSize() + ",'" +
					   ngasFile.getCompression() + "','" +
					   ngasFile.getIngestionDate() + "'," +
					   ngasFile.getIgnore() + ",'" +
					   ngasFile.getChecksum() + "','" + 
					   ngasFile.getChecksumPlugin() + "'," + 
					   ngasFile.getFileVersion() + ",'" +
					   ngasFile.getFileStatus() + "','" +
					   ngasFile.getCreationDate() + "')";
		
		ResultSet[] rs = new ResultSet[1];
		
		if( archiveService.executeQuery(query, rs) ) {
			affectedRows = 1;
		}
		
		return affectedRows;
	}
}
