package org.eso.util.datatransfer;

import java.lang.String;
import java.lang.Exception;

/** This exception is thrown by file handlers if a problem occurs whilst 
 * working with a file. 
 *
 * @author Stefano Zampieri <szampier@eso.org> 
 */
@SuppressWarnings("serial")
public class TransferRequestException extends Exception
{
    /** Creates a TransferRequestException with no detail message or cause. */
    public TransferRequestException()
    {
        super();
    }

    /** Creates a TransferRequestException with the specified detail message. 
     * 
     * @param message a detail message for this exception. 
     */
    public TransferRequestException(String message)
    {
        super(message);
    }

    /** Creates a TransferRequestException with the specified detail message 
     * and cause. 
     *
     * @param message a detail message for this exception. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public TransferRequestException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates a TransferRequestException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public TransferRequestException(Throwable cause)
    {
        super(cause);
    }
}
