package org.eso.util.datatransfer;

import java.util.Comparator;

import org.apache.log4j.Logger;

/**
 * Implements the Comparator interface to compare transfer requests according to
 * their priority.
 * 
 * @author szampier
 * 
 */
public class TransferRequestPriorityComparator implements Comparator<TransferRequest> {

	/** The name of this class for logging purposes. */
	static final String classLogName = "TransferRequestPriorityComparator";

	/** Apache Log4J logger. */
	static final Logger logger = Logger
			.getLogger(TransferRequestPriorityComparator.class);

	public int compare(TransferRequest leftObj, TransferRequest rightObj) {
		final String methodLogName = classLogName + "::compare()";
		try {
			return (leftObj.getPropertyAsInt(TransferRequest.TRANSFER_PRIORITY)
					.compareTo(rightObj
							.getPropertyAsInt(TransferRequest.TRANSFER_PRIORITY)));
		} catch (Exception e) {
			final String message = methodLogName
					+ " - exception caught while comparing transfer requests: "
					+ e.getMessage();
			logger.error(message);
			return 0;
		}
	}
}
