package org.eso.util.misc;


/**
 * This interface is used by the StatsKeeperTask to retrieve statistical
 * information about messages.
 * 
 * @author szampier
 *
 */
public interface StatsProvider {

	/**
	 * Returns true if this object can be processed by the StatsKeeperTask.
	 */
	boolean canProvideStats();

	/**
	 * Returns the start time of this object.
	 */
	long getStartTime();

	/**
	 * Returns the size (in bytes) of this object.
	 */
	long getSize();

	/**
	 * Returns the number of requests embedded in this object.
	 */
	int getNumElements();

}
