package org.eso.util.requesthandler;

/**
 * Implementation of a file part of a user request. It will be identified by the
 * identifer of the request it belongs to and its name
 * 
 * @author cmoins
 * 
 */
public class DatasetFile {
    // identifier of the request the file belongs to
    String reqNum;
    // name of the dataset the file belongs to
    // RIL: where does this name come from? It's not in the DatasetRequest
    // REPLY : in case of a SAF archive, the dataset name will be the data
    // product id, so it will be extracted from the raw file name.
    String datasetName;
    // Name of the file
    String name;
    // file status
    DatasetFileStatus status;
    // size of the file in bytes
    Long size;
    // name of the disk where the file is located
    String diskName;
    // directory section offset, equal to -1 for recent files
    Integer dirSectOff;

    public String getReqNum() {
        return reqNum;
    }

    public void setReqNum(String reqNum) {
        this.reqNum = reqNum;
    }

    public String getDatasetName() {
        return datasetName;
    }

    public void setDatasetName(String datasetName) {
        this.datasetName = datasetName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public DatasetFileStatus getStatus() {
        return status;
    }

    public void setStatus(DatasetFileStatus status) {
        this.status = status;
    }

    public Long getSize() {
        return size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public String getDiskName() {
        return diskName;
    }

    public void setDiskName(String diskName) {
        this.diskName = diskName;
    }

    public Integer getDirSectOff() {
        return dirSectOff;
    }

    public void setDirSectOff(Integer dirSectOff) {
        this.dirSectOff = dirSectOff;
    }
}
