package org.eso.util.requesthandler;

/**
 * Implementation of a dataset request option. An option is identified by a bit
 * mask and the archive (SAF,HST) it belongs to. An option is used by users
 * requesting data sets to specify either a process or a compression algorithm
 * to apply to data set files or the kind of media a request result will be
 * stored onto.
 * 
 * @author cmoins
 * 
 */

// RIM: In general I would recommend to document *domain classes* with more
// detail.
// They really are the core of the application.
// Please provide here, on class-level a description that says
// What does this class represent, (a request option).
// what is a request option, who uses it, what for
// REPLY : see above description
public class DatasetRequestOption {
 
    // Composite key to identify an option. It is made of a bit mask and the
    // archive the option belongs to
    private DatasetRequestOptionId id;
    // name of the option 
    DatasetRequestOptionName name;
    // option category, i.e whether the option specifies a process, a media
    // type, a formatting algorithm.
    private DatasetRequestOptionCategory uiCategory;

    // TODO : add description
    private String uiSelected;
    // TODO : add description
    private String applicability;
    // RIL: What's this?
    // TODO : add description
    // RIL: Why Float not float?
    // REPLY : floats are not java object and most of java's utility classes
    // require objects
    private Float multiplier;
    

    public DatasetRequestOptionId getId() {
        return id;
    }

    public void setId(DatasetRequestOptionId id) {
        this.id = id;
    }

    public DatasetRequestOptionName getName() {
        return name;
    }

    public void setName(DatasetRequestOptionName name) {
        this.name = name;
    }

    public DatasetRequestOptionCategory getUiCategory() {
        return uiCategory;
    }

    public void setUiCategory(DatasetRequestOptionCategory uiCategory) {
        this.uiCategory = uiCategory;
    }

    public String getUiSelected() {
        return uiSelected;
    }

    public void setUiSelected(String uiSelected) {
        this.uiSelected = uiSelected;
    }

    public String getApplicability() {
        return applicability;
    }

    public void setApplicability(String applicability) {
        this.applicability = applicability;
    }

    public Float getMultiplier() {
        return multiplier;
    }
    public void setMultiplier(Float multiplier) {
        this.multiplier = multiplier;
    }
}
