package org.eso.util.requesthandler;

import java.util.List;

/** Interface of DAO classes dealing with ngas files */
public interface NgasFileDAO {

    /**
     * Retrieves a list of files according to their file Id, their host domain
     * and their status
     * 
     * @param fileId
     *            id of the files to retrieve
     * @param domain
     *            domain of the host where files are located (HEADQUARTERS,
     *            LASILLA, PARANAL)
     * @param status
     *            files status (VALID)
     * @return a list of ngas files
     * @throws DAOException
     */
    // RIL - "public" is not necessary. It is by default.
    // REPLY If no convention prevents it, i find it clearer to specify the
    // access level
    public List<NgasFile> findByFileIdAndDomainAndStatus(String fileId,
            NgasHostDomain domain, NgasFileStatus status) throws DAOException;
}
