package org.eso.util.requesthandler;

import java.util.List;


import org.eso.util.requesthandler.DAOException;
import org.eso.util.requesthandler.NgasFile;
import org.eso.util.requesthandler.NgasFileDAO;
import org.springframework.test.AbstractDependencyInjectionSpringContextTests;

public class NgasFileDAOTest extends
        AbstractDependencyInjectionSpringContextTests {

    private NgasFileDAO ngasFileDAO;

    @Override
    protected String[] getConfigLocations() {
        // TODO Auto-generated method stub
        return new String[] { "config/spring/db.xml",
                "config/spring/hibernate.xml", "config/spring/dao.xml",
                "config/spring/transaction.xml" };
    }

    /** Nominal case for the find method */
    public void testFindByOptionAndArchive_01() {
        final String FILE_ID="WFCAM.2006-06-03T14:15:19.008";
        final NgasHostDomain DOMAIN = NgasHostDomain.HEADQUARTER;
        final NgasFileStatus STATUS = NgasFileStatus.VALID;        
        try {
            List<NgasFile> ngasFileList =
                    ngasFileDAO.findByFileIdAndDomainAndStatus(FILE_ID,DOMAIN,STATUS);
            assertTrue(ngasFileList.size() >= 1);

        } catch (DAOException e) {
            fail("An exception was thrown" + e.getMessage());
        }
    }


    public void setNgasFileDAO(NgasFileDAO ngasFileDAO) {
        this.ngasFileDAO = ngasFileDAO;
    }

 

}
