package org.eso.dfs.datatransfer;

import java.util.ArrayList;
import java.util.List;

/**
 * @author nkornwei
 *
 * Generic event used to record a file list event
 */
public class FileListEvent {
    
    /**
     * List of File objects.
     */
    private List fileList;
    
    /**
     * Create an event with an empty file list.
     */
    public FileListEvent() {
        fileList = new ArrayList();
    }
    
    /**
     * Create an event with the specified List of File objects.
     */
    public FileListEvent(List fList) {
        if (fList == null) {
            fileList = new ArrayList();
        } else {
            fileList = fList;
        }
    }
    
    /**
     * Get the file list
     * @return List of File objects.
     */
    public List getFileList() {
        return fileList;
    }
}
