package org.eso.gasgano;

import jal.String.Sorting;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.Dialog.ModalExclusionType;
import java.awt.Dialog.ModalityType;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.TreePath;

import org.eso.cpl.CPLException;
import org.eso.cpl.Recipe;
import org.eso.cpl.RecipeLibrary;
import org.eso.cpl.gui.CPLFrame;
import org.eso.cpl.gui.RecipeSelector;
import org.eso.cpl.jni.LTDLException;
import org.eso.cpl.jni.LibraryLoader;
import org.eso.cpl.jni.PluginLibrary;
import org.eso.dfs.datatransfer.FileListEvent;
import org.eso.dfs.datatransfer.FileListImportListener;
import org.eso.dfs.gui.SwingFileChooser;
import org.eso.dfs.services.gui.FileImageDisplayService;
import org.eso.gasgano.cpl.RecipePanelList;
import org.eso.gasgano.datamodel.BasicFileDescription;
import org.eso.gasgano.datamodel.NotFoundOBComponent;
import org.eso.gasgano.datamodel.OBComponentFilter;
import org.eso.gasgano.datamodel.ReductionBlockCommon;
import org.eso.gasgano.datamodel.ResultsModel;
import org.eso.gasgano.datamodel.database.DBDataModel;
import org.eso.gasgano.datamodel.database.FileDownloader;
import org.eso.gasgano.datamodel.filesystem.DFSDataModel;
import org.eso.gasgano.datamodel.filesystem.DFSFile;
import org.eso.gasgano.datamodel.filesystem.DirectoryFileSelectionModel;
import org.eso.gasgano.datamodel.filesystem.FitsFile;
import org.eso.gasgano.datamodel.filesystem.FitsFileReport;
import org.eso.gasgano.datamodel.gui.DBOBComponent;
import org.eso.gasgano.datamodel.gui.KeywordContainerOBComponent;
import org.eso.gasgano.datamodel.gui.OBComponent;
import org.eso.gasgano.datamodel.gui.ReductionBlockOBComponent;
import org.eso.gasgano.datamodel.gui.ResultsComponent;
import org.eso.gasgano.datamodel.gui.VirtualReductionBlockOBComponent;
import org.eso.gasgano.dfspipeline.DFSPipelineEnvironment;
import org.eso.gasgano.dfspipeline.InfrastructureWatch;
import org.eso.gasgano.gui.ClassificationRuleFileEditor;
import org.eso.gasgano.gui.DBTreeTableModel;
import org.eso.gasgano.gui.DFSFileTreeTable;
import org.eso.gasgano.gui.DFSFileTreeTableModel;
import org.eso.gasgano.gui.DataModelBuilder;
import org.eso.gasgano.gui.FileListChooser;
import org.eso.gasgano.gui.FileListModel;
import org.eso.gasgano.gui.FileListPane;
import org.eso.gasgano.gui.FilterBuilder;
import org.eso.gasgano.gui.GUIUtils;
import org.eso.gasgano.gui.KeywordListEditorFrame;
import org.eso.gasgano.gui.KeywordListLoader;
import org.eso.gasgano.gui.ReportViewer;
import org.eso.gasgano.gui.ResultsTreeTableModel;
import org.eso.gasgano.keyword.ExpressionTable;
import org.eso.gasgano.keyword.Keyword;
import org.eso.gasgano.properties.GasProp;
import org.eso.gasgano.properties.GasPropListener;
import org.eso.gasgano.properties.PropertyDB;
import org.eso.gasgano.tools.DirUtils;
import org.eso.gasgano.tools.PasswordSource;
import org.eso.oca.parser.ParseException;

/**
 * Main display component for Gasgano - way too monlithic.
 * Handles primary GUI components, and data models.
 * TODO: refactoring: further refactoring required - too large and encompasing.
 * Too many other classes link to this class.
 */
public class GasganoDisplay
    extends JFrame
    implements ActionListener, ChangeListener, GasPropListener {

    private DFSFileTreeTable fsTree;
    private DFSFileTreeTableModel fsTreeModel;

    private DBTreeTable dbTree;
    private DBTreeTableModel dbTreeModel;

    private TreeControlPanel treeControlPanel;
    private DBTreeControlPanel dbTreeControlPanel;
    private DFSDataModel dataModel;

    private TreeControlPanel resTreeControlPanel;
    private ResultsModel resDataModel;
    private ResultsTreeTableModel resTreeModel;
    private ResultsTreeTable resTree;

    private DBDataModel dbDataModel;
    private DirectoryFileSelectionModel fileSelections;
    private DirectoryFileSelectionModel backupFileSelections;
    /**
     * Split pane containing the File tree table in the upper and
     * either: the lower split pane or the detail panel, depending on the
     * setting of isShowFileLists().
     */
    private JSplitPane splitPane;
    /**
     * Split pane containing the file association panel (middle panel)
     * and the detail panel. This split pane is only used when
     * isShowFileLists() is true.
     */
    private JSplitPane lowerSplitPane;

    /**
     * The file list pane shows file associations between RBs, products
     * and raw files - this is only needed if Gasgano is running in the
     * DFS pipeline environment - i.e. isShowFileLists() is true.
     */
    private FileListPane fileListPane;

    private FileListChooser fileListChooser;
    private JFileChooser fileChooser;
    private JPanel blankDetail;
    private FilterBuilder fltBuilder;
    private KeywordListEditorFrame kwListEditor;
    private KeywordListLoader kwListLoader;
    private ScriptDirBoard scriptBoard;
    private DisplayOrganizer displayOrganizer;
    private GasPropEditor propertyEditor;

    /**
     * Backup of current GasProp instance - this is set when the GasPropEditor
     * is created and used when properties change (newProperties()).
     */
    private GasProp backupPrefs;

    private JTabbedPane tabbedPane;
    private JPanel fsTreePanel;
    private JPanel dbTreePanel;
    private JPanel resTreePanel;
    private JScrollPane fsTreeView;
    private JScrollPane dbTreeView;
    private JScrollPane resTreeView;

    private JPopupMenu selectedFilesPopupMenu;

    /**
     * List of all recipe panels displayed.
     */
    private RecipePanelList recipePanels = new RecipePanelList();

    /**
     * file chooser for retreiving files from the database.
     */
    private JFileChooser retrieveFileChooser;

    private boolean fsSelected = true;
    private boolean dbSelected = false;
    private boolean resSelected = false;

    private static final String addRmFileLabel = "Add/Remove Files...";
    private static final String reclassifyLabel = "Reclassify";
    private static final String refreshLabel = "Refresh";
    private static final String editPreferencesLabel = "Preferences...";
    private static final String mvFileLabel = "Move...";
    private static final String externalViewerLabel = "Display...";
    private static final String toRecipeLabel = "To Recipe";
    private static final String toQueueLabel = "To Recipe Request Pool";
    private static final String openRecipeLabel = "Load Recipe";
    private static final String cpFileLabel = "Copy...";
    private static final String tarFileLabel = "Tar...";

    private static final String reportFileLabel = "Report...";
    private static final String appFileLabel = "Run...";
    private static final String classBldrLabel = "Classification Rules...";
    private static final String kwListEditorLabel = "Edit Keyword Lists...";
    private static final String scriptBoardLabel = "Script Board";
    private static final String recipePanelLabel = "Recipe Panel";
    private static final String whoIsGasganoLabel = "Who is Gasgano";
    private static final String overviewLabel = "Overview";
    private static final String userInputLabel = "User Input";
    private static final String initialSetupLabel = "Setup";

    // do not remove space at the end of the following string
    private static final String preferencesLabel = "Preferences ";
    private static final String associationLabel = "Association";
    //private static final String databaseLabel = "Database";
    private static final String externalCommandsLabel = "External Commands";
    
    private static final String addFilterLabel = "Filter Files";
    private static final String rmFilterLabel = "Unfilter files";
    private static final String quitLabel = "Quit";

    /**
     * Recipe Library loader, instantiated when first required
     */
    private LibraryLoader loader;

    /**
     * The location of the help files.
     */
    private static final String helpDir = "help/";

    static final int[] menuZeroList = { 0, 1, 2, 3, 4 };
    static final int[] menuOneList = { 1, 2, 3, 4 };

    private boolean dataBaseOn = false;
    private boolean safeEnvironment = false;
    final private Cursor waitCursor = new Cursor(Cursor.WAIT_CURSOR);
    private JMenuItem dualFilterItem = null;

    private int debugLevel = 0;

    /**
     * setting determining if the DFS pipeline environment is configured or not
     * -1: not initialized
     * 0: no dfs pipeline env configured
     * 1: dfs pipeline env configured.
     * To be accessed through isDFSPipelineEnvironment().
     */
    private int inDFSPipeEnv = -1;

    /**
     * True if the file lists are to be displayed, else false.
     */
    private boolean showFileLists = true;

    /**
     * Tab pane tab labels for file association panel (middle panel).
     */
    private static final String[] tabLabels =
        {
            "Raw Files",
            "Master Calib. Files",
            "Reduction Block Files",
            "Product Files" };

    /**
     * Empty list pabels used in the file association panel (middle panel).
     */
    private static final String[] emptyListLabels =
        {
            "No associated raw files",
            "No associated master calibration files",
            "No associated reduction block files",
            "No associated product files" };

    private javax.swing.Timer updateTimer = null;

    /**
     * Create and display the main Gasgano panel.
     * @param title
     * @param m
     * @param dbm
     * @param resm
     */
    public GasganoDisplay(
        String title,
        DFSDataModel m,
        DBDataModel dbm,
        ResultsModel resm) {
        super(title);
        dataModel = m;
        dbDataModel = dbm;
        resDataModel = resm;
        displayOrganizer = new DisplayOrganizer();

        if (((String) PropertyDB.getInstance().getProperty("DBOBS_REQUIRED"))
            .equals("true")) {
            dataBaseOn = true;
        }

        safeEnvironment = GasProp.isEnvironmentSafe();

        // File system AREA
        setupFileSystemArea();

        if (safeEnvironment) {
            // Database AREA
            setupDatabaseArea();
        }

        // Results AREA
        setupResultsArea();

        // this is maybe in the wrong place
        resTreePanel.add(resTreeControlPanel, "North");
        resTreePanel.add(resTreeView, "Center");

        fsTreePanel.add(treeControlPanel, "North");
        fsTreePanel.add(fsTreeView, "Center");

        tabbedPane = new JTabbedPane(SwingConstants.BOTTOM);
        tabbedPane.setFont(new Font("DialogInput", Font.PLAIN, 10));
        tabbedPane.addChangeListener(this);

        if (safeEnvironment) {
            setDatabasePanelEnabled(false);
        }

        // set this Dimension to center the JSplitPane divider as
        // JSplitPane.setDividerLocation(double) does not work!
        fsTreePanel.setPreferredSize(new Dimension(300, 300));
        fsTreePanel.setMinimumSize(new Dimension(300, 110));

        splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        splitPane.setOneTouchExpandable(true);

        lowerSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        lowerSplitPane.setOneTouchExpandable(true);

        /*
         * The panels are setup to show the file list - if it is not
         * to be shown, it is re-organized to hide the panel with
         * a call to irganizePanels();
         */
        setupFileListPane();
        lowerSplitPane.setTopComponent(fileListPane);
        splitPane.setBottomComponent(lowerSplitPane);
        showBlankDetail(true);
        getContentPane().add(splitPane);

        // set show file lists property and panel organization
        // based on DFS Pipeline Env setting.
        // This call must be made AFTER the split panes and
        // panels have been set up, and before the addMenu() call.
        setShowFileLists(isDFSPipelineEnvironment());

        try {
			fileSelections = new DirectoryFileSelectionModel(new String[] {});
		} catch (IOException ioe) {
			// this should never happen
			final String errMsg = (ioe.getMessage().length() > 500 ? ioe.getMessage().substring(0, 500) + "[...]" : ioe.getMessage()); 
			GUIUtils.userMessage(
					this,
					"One or more errors found while initializing DirectoryFileSelectionModel" +
					errMsg
					);
		}

        fileListChooser = new FileListChooser();

        // This call must be made after setShowFileLists is initialized.
        addMenu();

        splitPane.setTopComponent(fsTreePanel);
        pack();

        if (safeEnvironment) {
            if (dataBaseOn) {
                setDatabaseEnabled(true);
            } else {
                setDatabaseEnabled(false);
            }
        }

        int updateMinutes = 0;
        updateTimer = new javax.swing.Timer(0, this);
        try {
            updateMinutes =
                Integer.parseInt(
                    PropertyDB.getInstance().getProperty("UPDATE_TIMER"));
            if (updateMinutes != 0) {
                updateTimer.setDelay(updateMinutes * 60000);
                updateTimer.setInitialDelay(updateMinutes * 60000);
                updateTimer.start();
            }
        } catch (Exception ex) {
            // what to do here.??
            System.out.println("Failed to create/start the update timer.");
            ex.printStackTrace();
        }
        // DFS Pipeline Environment setup 
        if (isDFSPipelineEnvironment()) {
            InfrastructureWatch infraWatch = new InfrastructureWatch();
            infraWatch.addDFSPipelineStatusListener(treeControlPanel);
            infraWatch.start();
        }

        registerKeyboard();
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        Rectangle rec =
            GUIUtils.stringToRect(
                PropertyDB.getInstance().getProperty("FRAME_BOUNDS"));
        if (rec == null) {
            PropertyDB.getInstance().setProperty(
                "FRAME_BOUNDS",
                GasProp.FRAME_BOUNDS);
        }
        rec =
            GUIUtils.stringToRect(
                PropertyDB.getInstance().getProperty("FRAME_BOUNDS"));
        setBounds(rec);
        setVisible(true);
        fsTree.registerColumnListener();
        fsTree.setColumnWidths();
        
        // DS FEB 2007 - DFS02755 (filter file on startup)
        selectFirstFileFilter();
    }

    /**
     * Get the JSplitPane containing the detail panel.
     * @return JSplitPane containing the detail panel. This will either
     * be the lowerSplitPane or the splitPane, depending on the DFSPipeline
     * Environment setting.
     */
    private JSplitPane getDetailPanelContainer() {
        return isShowFileLists() ? lowerSplitPane : splitPane;
    }

    /**
     * DFS Pipeline Environment configured?.
     * @return boolean true if Gasgano is configured for the 
     * dfs pipeline environment - this is a setting in the system
     * properties.
     */
    public boolean isDFSPipelineEnvironment() {
        return DFSPipelineEnvironment.getInstance().isPipelineEnvironment();
    }

    /**
     * utility method to setup results tree.
     */
    protected void setupResultsArea() {
        resTreeModel = new ResultsTreeTableModel(resDataModel);
        resTree = new ResultsTreeTable(resTreeModel, this);
        resTreeView = new JScrollPane(resTree);
        resTreePanel = new JPanel(new BorderLayout());
        resTreeControlPanel = new TreeControlPanel(resTree, resTreeModel, this);
        //resScreenPanel = new ScreenPanel(resTreeView);
    }

    /**
     * utility method to setup database tree.
     */
    protected void setupDatabaseArea() {
        dbTreeModel = new DBTreeTableModel(dbDataModel);
        dbTree = new DBTreeTable(dbTreeModel, this);
        dbTreeView = new JScrollPane(dbTree);
        dbTree.getTree().addTreeSelectionListener(displayOrganizer);
        dbTreePanel = new JPanel(new BorderLayout());
        //dbScreenPanel = new ScreenPanel(dbTreeView);
        dbTreeControlPanel = new DBTreeControlPanel(dbTree, dbTreeModel, this);
    }

    /**
     * utility method to setup file system tree and register the file list
     * drop handler.
     */
    protected void setupFileSystemArea() {
        // FileSystem AREA
        fsTreeModel = new DFSFileTreeTableModel(dataModel);
        fsTree = new DFSFileTreeTable(fsTreeModel);

        // setup call back to receive file drop events in the tree.
        fsTree.addFileListImportListener(new FileListImportListener() {
            public void importFileListEvent(FileListEvent event) {
                String dirs[] = new String[event.getFileList().size()];
                Iterator i = event.getFileList().iterator();
                int idx = 0;
                while (i.hasNext()) {
                    dirs[idx] = ((File) i.next()).getPath();
                    idx++;
                }
                updateFileSelectionAndRefresh(dirs, false);
            }
        });

        // setup right mouse menu on the tree
        fsTree.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                processEvent(e);
            }
            public void mouseReleased(MouseEvent e) {
                processEvent(e);
            }
            private void processEvent(MouseEvent e) {
                if (e.isPopupTrigger()) {
                    // get the row for the click and if the row is selected,
                    // display the menu.
                    int row = fsTree.rowAtPoint(new Point(e.getX(), e.getY()));
                    if (row >= 0 && fsTree.isRowSelected(row)) {
                        selectedFilesPopupMenu.show(
                            e.getComponent(),
                            e.getX(),
                            e.getY());
                    }
                }
            }
        });
        fsTreeView =
            new JScrollPane(
                fsTree,
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        fsTree.getTree().addTreeSelectionListener(displayOrganizer);
        fsTreePanel = new JPanel(new BorderLayout());
        //fsScreenPanel = new ScreenPanel(fsTreeView);
        treeControlPanel = new TreeControlPanel(fsTree, fsTreeModel, this);
        FileImageDisplayService.getInstance().addFileImageDisplayHandler(
            treeControlPanel);
    }

    /**
     * intended to be used when the preferences change, <p>
     * when the database facility is activated or de-activated<p>
     */
    public void setDatabaseEnabled(boolean b) {
        if (b) {
            if (splitPane.getTopComponent() != null) {
                splitPane.remove(splitPane.getTopComponent());
            }
            tabbedPane.removeAll();
            tabbedPane.add("Filesystem", fsTreePanel);
            tabbedPane.add("Database", dbTreePanel);
            tabbedPane.repaint();

            splitPane.setTopComponent(tabbedPane);
            dbDataModel.setPasswordSource(getPasswordSource());
        } else {
            if (splitPane.getTopComponent() != null) {
                splitPane.remove(splitPane.getTopComponent());
            }
            tabbedPane.remove(fsTreePanel);
            splitPane.setTopComponent(fsTreePanel);
            //dockComponent(fsScreenPanel, fsTreeView);
            setDatabasePanelEnabled(false);
            dbDataModel.cleanup();
        }
    }

    /**
     * implementation of changeListener interface
     * @param: the ChangeEvent
     * we only care of those coming from 
     * the main tabbedPane. <p>
     * Main purpose of this method is to switch the 
     * screens on and off by adding or removing<p>
     * them from the LayeredPane.<p>
     */
    public void stateChanged(ChangeEvent e) {
        if (e.getSource() == tabbedPane) {
            if (tabbedPane.getSelectedComponent() == dbTreePanel) {
                if (dbTreePanel.getComponent(0) == GUIUtils.gasgLabel3
                    && !dbDataModel.isUpdating()) {
                    initDb();
                }
                fsSelected = false;
                dbSelected = true;
                resSelected = false;

                for (int i = 0; i < menuZeroList.length; i++) {
                    getJMenuBar().getMenu(0).getMenuComponent(
                        menuZeroList[i]).setEnabled(
                        false);
                }
                for (int i = 0; i < menuOneList.length; i++) {
                    getJMenuBar().getMenu(1).getMenuComponent(
                        menuOneList[i]).setEnabled(
                        false);
                }
            }
            if (tabbedPane.getSelectedComponent() == fsTreePanel) {

                fsSelected = true;
                dbSelected = false;
                resSelected = false;

                for (int i = 0; i < menuZeroList.length; i++) {
                    getJMenuBar().getMenu(0).getMenuComponent(
                        menuZeroList[i]).setEnabled(
                        true);
                }
                for (int i = 0; i < menuOneList.length; i++) {
                    getJMenuBar().getMenu(1).getMenuComponent(
                        menuOneList[i]).setEnabled(
                        true);
                }
            }

            if (tabbedPane.getSelectedComponent() == resTreePanel) {

                // this is a temporary setup
                resDataModel.cleanup();
                JFileChooser tpfc = new SwingFileChooser();
                tpfc.setMultiSelectionEnabled(false);
                if (tpfc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
                    if (tpfc.getSelectedFile() != null) {
                        resDataModel.init(
                            resDataModel.tmpAssessTiraPackInfo(
                                tpfc.getSelectedFile().getPath()));
                        resTreeModel.updateTree();
                    }
                }

                fsSelected = false;
                dbSelected = false;
                resSelected = true;

                for (int i = 0; i < menuZeroList.length; i++) {
                    getJMenuBar().getMenu(0).getMenuComponent(
                        menuZeroList[i]).setEnabled(
                        false);
                }
                for (int i = 0; i < menuOneList.length; i++) {
                    getJMenuBar().getMenu(1).getMenuComponent(
                        menuOneList[i]).setEnabled(
                        false);
                }
            }
            getLayeredPane().repaint();
        }
    }

    /**
     * once the database is active, this method is used<p>
     * to switch between a waiting state (with funny picture in the background)<p>
     * and a working state (enabled)<p>
     */
    public void setDatabasePanelEnabled(boolean b) {
        if (b) {
            tabbedPane.setForeground(Color.magenta);
            dbTreePanel.remove(GUIUtils.gasgLabel3);
            dbTreePanel.add(dbTreeControlPanel, "North");
            dbTreePanel.add(dbTreeView, "Center");
            dbTreePanel.validate();
            dbTreePanel.repaint();
        } else {
            tabbedPane.setForeground(Color.black);
            dbTreePanel.removeAll();
            dbTreePanel.add(GUIUtils.gasgLabel3);
            dbTreePanel.validate();
            dbTreePanel.repaint();
        }
    }

    /**
     * all graphical elements for the Database panel 
     * are allocated here, <p> provided that DBDataModel.init succeeds.<p>
     * Otherwise a beep is emitted and the TabbedPane returns to the
     * filesystem view<p>
     */
    private void initDb() {
        final Cursor cursorBack = getCursor();
        new Thread(new Runnable() {

            public void run() {
                dbTreePanel.validate();
                GasganoDisplay.this.setCursor(waitCursor);
                if (!dbDataModel.init()) {
                    Toolkit toolkit = Toolkit.getDefaultToolkit();
                    // bail out if anything went wrong
                    GasganoDisplay.this.setCursor(cursorBack);
                    toolkit.beep();
                    tabbedPane.setSelectedComponent(fsTreePanel);
                    return;
                }
                dbTreeModel.updateTree();
                setDatabasePanelEnabled(true);
                GasganoDisplay.this.setCursor(cursorBack);
            }
        }).start();
    }

    /**
     * fundamental method, implementing the ActionListener interface<p>
     * entry point for all menu controlled events, plus timer.
     * 
     * Note: not all actions are included here - many actions have been
     * implemented through anonymouse classes extending AbstractAction.
     */
    public void actionPerformed(ActionEvent a) {
        if (a.getSource() == updateTimer) {
            // System.err.println(">> Forcing refresh");
            // set the cursor to waiting
            // disable refresh Action in menubar
            Cursor c = getCursor();
            getJMenuBar().getMenu(0).getItem(5).setEnabled(false);
            setCursor(waitCursor);
            refreshModelWithoutWindow();
            getJMenuBar().getMenu(0).getItem(5).setEnabled(true);
            setCursor(c);
        }
        if (a.getActionCommand() == quitLabel) {
            System.exit(0);
        } else if (a.getActionCommand() == addRmFileLabel) {
            addFile();
        } else if (a.getActionCommand() == addFilterLabel) {
            showExpressionBuilder();
        } else if (a.getActionCommand() == rmFilterLabel) {
            setFilter(null);
        } else if (a.getActionCommand() == reclassifyLabel) {
        	//
        	// Reload the rule file and reclassify all the files in the data model.
        	// 
        	// Reloading the rule file is a very quick operation and it can be useful
        	// especially when the user has modified the rule file with an external
        	// editor and wants to try it and/or check for errors.
        	//
        	final String ruleFile = PropertyDB.getInstance().getProperty("CLASSRULE_FILE");
            if(loadAndUpdateClassifier(ruleFile) == true) {
                reclassifyModel();
            }
        } else if (a.getActionCommand() == refreshLabel) {
            refreshModel();
        } else if (a.getActionCommand() == editPreferencesLabel) {
            backupPrefs = new GasProp(GasProp.getProperties());
            if (propertyEditor == null) {
            	// create the editor
                propertyEditor = new GasPropEditor();
                // if the user changes the classification rule file, this code
                // is executed in oder to automatically reclassify all files
                propertyEditor.setReclassificationListener(
                	new GasPropEditor.ReclassificationListener() {
                		public void reclassifyNow() {
                        	final String ruleFile =
                        		PropertyDB.getInstance().getProperty("CLASSRULE_FILE");
                            if(loadAndUpdateClassifier(ruleFile) == true) {
                                reclassifyModel();
                            }
                		}
                	}
                );
            } else {
                // update property editor with current properties.
                propertyEditor.loadProperties();
            }
            propertyEditor.startEditing();
        } else if (a.getActionCommand() == classBldrLabel) {
            showClassificationRuleFileEditor();
        } else if (a.getActionCommand() == kwListEditorLabel) {
            showKeywordListEditor();
        } else if (a.getActionCommand() == scriptBoardLabel) {
            toggleScriptBoard();
        } else if (a.getActionCommand() == recipePanelLabel) {
            showRecipePanel();
        } else if (a.getActionCommand() == whoIsGasganoLabel) {
            showGasgano();
        } else if (a.getActionCommand() == overviewLabel) {
            showHelp("Overview.html");
        } else if (a.getActionCommand() == userInputLabel) {
            showHelp("UserInput.html");
        } else if (a.getActionCommand() == initialSetupLabel) {
            showHelp("InitialSetup.html");
        } else if (a.getActionCommand() == preferencesLabel) {
            showHelp("Preferences.html");
            // } else if (a.getActionCommand() == databaseLabel) {
            //    showHelp("Database.html");
        } else if (a.getActionCommand() == associationLabel) {
            showHelp("Association.html");
        } else if (a.getActionCommand() == externalCommandsLabel) {
            showHelp("External.html");
        }
    }

    /**
     * helper method to show a basic online help page<p>
     * calls the userMessage method<p>
     * @param: the page name - the page must be located under the hedlDir 
     * directory.
     */
    private void showHelp(String htmlPage) {
        JEditorPane html = null;
        URL url = null;
        url = GasganoDisplay.class.getResource(helpDir + htmlPage);

        if (url != null) {
            try {
                html = new JEditorPane(url);
                html.setPreferredSize(new Dimension(400, 600));
                html.setMinimumSize(new Dimension(400, 600));
                JScrollPane jsp = new JScrollPane(html);
                html.setEditable(false);
                jsp.setMinimumSize(new Dimension(470, 750));
                jsp.setPreferredSize(new Dimension(470, 750));
                GUIUtils.userMessage(this, jsp);

            } catch (IOException ioe) {
                System.out.println(ioe);
            }
        } else {
            System.err.println("URL null");
            GUIUtils.userMessage(
                this,
                "Help page could not be displayed.\nURL for "
                    + htmlPage
                    + " is empty!");
        }
    }

    /**
     * Action callback to show our cute little animal
     */
    private void showGasgano() {
        String gasganoText =
            new String(
                "Although the 24-fingered Xexto\n"
                    + "has never beaten Sebulba, Gasgano\n"
                    + "is a popular favorite in the Boonta Eve\n"
                    + "Podrace. Racing on behalf of Gardulla\n"
                    + "the Hutt, Gasgano is the subject of\n"
                    + "frenzied betting between Gardulla\n"
                    + "and Jabba.");
        JPanel gasganoIcon = new JPanel();
        JTextArea desc = new JTextArea(gasganoText);
        desc.setEditable(false);
        gasganoIcon.add(desc, "Center");
        gasganoIcon.add(GUIUtils.gasgLabel1, "East");
        GUIUtils.userMessage(this, gasganoIcon);
    }

    /**
     * Shows a form for editing the rule file.
     * @return true if the file has been changed.
     */
    private boolean showClassificationRuleFileEditor() {

    	final File file = new File(PropertyDB.getInstance().getProperty("CLASSRULE_FILE"));
    	String ruleFile = "[unknown]";
    	try {
    		ruleFile = file.getCanonicalPath();
		} catch (IOException e) {
			// just ignore, the editor will fail
		}
			
		try {
			if (!file.exists()) {
				if (!file.getParentFile().exists()) {
						GUIUtils.userError(this,
								"Unable to create rules file [" + ruleFile + "].\n" +
								"Parent directory doesn't exist [" + file.getParentFile().getAbsolutePath() + "].\n");
						return false;
				} 
				
				try {
					if (file.createNewFile()) {
						GUIUtils.userMessage(this,
								"Successfully created empty rules file [" +
								ruleFile + "].\n");
					} else {
						GUIUtils.userError(this,
								"Unable to create rules file [" +
								ruleFile + "].\n");
						return false;
					} 
				} catch (IOException e) {
					GUIUtils.userError(this,
							"Unable to create rules file [" +
							ruleFile + "].\n" + e.getMessage());
					return false;
				}

			}
			ClassificationRuleFileEditor editor = new ClassificationRuleFileEditor(ruleFile);
			editor.setModalityType(ModalityType.APPLICATION_MODAL);
			editor.setLocationRelativeTo(this);
			editor.setVisible(true); // blocks until the dialog is closed by the user
			
			if( editor.isRuleFileChanged() ) {
				dataModel.setClassifier(
					DFSDataModel.createClassifier(
							new FileInputStream(ruleFile)
						)
					);
				
                reclassifyModel();
			}
			
		} catch (Exception e) {
			GUIUtils.userMessage(this,
					"Unexpected exception while accessing rules file ["
							+ ruleFile + "].\n" + e.getMessage());
		} catch (Error e) {
			GUIUtils.userMessage(this,
					"Unexpected error while accessing rules file [" + ruleFile
							+ "].\n" + e.getMessage());
		}	
	
		return false;
    }

    /**
     * pops up an editor for keyword-based header filters
     */
    private void showKeywordListEditor() {
        if (kwListEditor == null) {
            kwListEditor = new KeywordListEditorFrame();
            kwListEditor.pack();
            kwListEditor.setLocation(200, 400);
        }
        kwListEditor.setVisible(true);
    }

    /**
     * instantiates new ScriptDirBoard if needed, otherwise
     * just calls the methods to show and hide the board<p>
     * Notifies the user if Scripts directory does not exist<p>
     * Needs to be public to be accessed by the TreeControlPanel<p>
     * @see: TreeControlPanel
     */
    public void toggleScriptBoard() {
        if (scriptBoard != null && scriptBoard.isVisible()) {
            scriptBoard.hideBoard();
        } else {
            if (scriptBoard == null) {
                String scriptDir = null;
                String scriptPrefs =
                    new String(
                        PropertyDB.getInstance().getProperty("SCRIPTS_DIR"));
                scriptDir = DirUtils.convertAbsoluteDir(scriptPrefs);
                if (!new File(scriptDir).isDirectory()) {
                    GUIUtils.userMessage(
                        this,
                        "The Scripts directory either does not exist\nor is not a directory\nCheck your preferences!");
                    return;
                }
                scriptBoard = new ScriptDirBoard(scriptDir, this, fsTree);
                scriptBoard.setLocation(200, 400);
                // add the  TreeSelectionListener
                DefaultTreeSelectionModel selectionModel =
                    (DefaultTreeSelectionModel) fsTree
                        .getTree()
                        .getSelectionModel();
                selectionModel.addTreeSelectionListener(scriptBoard);
            }
            scriptBoard.pack();
            scriptBoard.showBoard();
        }
    }

    /**
     * Load the library containing the named recipe and display it in a CPLFrame, 
     * including as input frames the current selection from the treeview.
     * If the library/recipe could not be loaded, a message is displayed to the
     * user.
     * @param recipeName
     */
    public void showRecipePanel(String recipeName) {
        Recipe rc = null;
        PluginLibrary lib = null;
        Cursor origCursor = getCursor();
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        try {
            if (loader == null) {
                // lazily instantiate the library loader.
                loader = new LibraryLoader();
            }
            // find the first library containing the recipe with the name
            // we are looking for (this is a current limitation: recipe names
            // must be unique system wide.
            Iterator libNameIter =
                GasProp.getProperties().getRecipeLibraryNames();
            while (lib == null && libNameIter.hasNext()) {
                String libName = (String) libNameIter.next();
                List recipeNames =
                    GasProp.getProperties().getRecipesForLibrary(libName);
                if (recipeNames != null) {
                    Iterator recNameIter = recipeNames.iterator();
                    while (lib == null && recNameIter.hasNext()) {
                        String recName = (String) recNameIter.next();
                        if (recName.equals(recipeName)) {
                            // found library cointaining the rquired recipe.
                            try {
								lib = loader.getLibrary(libName);
							} catch (CPLException cplEx) {
								GUIUtils.userMessage(
										this,
										"Cannot load library " + libName + "\n" +
										cplEx.getMessage()
										);
							}
                        }
                    }
                }
            }
            if (lib != null) {
                Recipe[] recipes = lib.getRecipes();
                for (int r = 0; r < recipes.length; r++) {
                    if (recipes[r].getName().equals(recipeName)) {
                        rc = recipes[r];
                        break;
                    }
                }
            }
            if (lib == null) {
                if (origCursor != null) {
                    setCursor(origCursor);
                    origCursor = null;
                }
                GUIUtils.userMessage(
                    this,
                    "No library found containing recipe: " + recipeName);
            } else if (rc == null) {
                if (origCursor != null) {
                    setCursor(origCursor);
                    origCursor = null;
                }
                GUIUtils.userMessage(
                    this,
                    "Recipe "
                        + recipeName
                        + " not found in library "
                        + lib.getName());
            }
        } catch (LTDLException e) {
            if (origCursor != null) {
                setCursor(origCursor);
                origCursor = null;
            }
            GUIUtils.userMessage(this, e.getMessage());
        } catch (Error e) {
            // it is not recommended to continue after catching an error
            // this catch statement displays a user message and exits
            e.printStackTrace();
            GUIUtils.userMessage(this, "Fatal Error", e.getMessage());
            System.exit(-1);
        }

        if (rc != null) {
            recipePanels.addRecipePanel(
                rc,
                fsTree.getSelectedOBComponents(),
                loader);
        }
        if (origCursor != null) {
            setCursor(origCursor);
            origCursor = null;
        }
    }

    /**
     * Add the current frame selection to the named panel. If the panel is not
     * in the recipePanels list, an error is displayed to the user.
     * @param panelName
     * @param queue add the frames to the queue, or to the current panel.
     */
    private void addSelectedFilesToRecipePanel(
        String panelName,
        boolean queue) {
        if (recipePanels.getRecipePanel(panelName) != null) {
            recipePanels.addInputFramesToRecipePanel(
                panelName,
                fsTree.getSelectedOBComponents(),
                queue);
        } else {
            // named panel was not found in the list of open panels.recipePanels.getRecipePanel(panelName);
            GUIUtils.userMessage(
                this,
                "Recipe panel " + panelName + " not found");
        }
    }

    /**
     * Private method to prompt the user to select a recipe, and
     * then display the Recipe Panel based on the selected recipe.
     */
    private void showRecipePanel() {
        final JFrame frame = new JFrame();
        List plugins = new ArrayList();
        RecipeLibrary[] libs = null;
        try {
            RecipeLibrary lib;

            if (loader == null) {
                // lazily instantiate the library loader.
                loader = new LibraryLoader();
            }

            Iterator i = GasProp.getProperties().getRecipeLibraryNames();
            while (i.hasNext()) {
                String libName = (String) i.next();
                List recipes =
                    GasProp.getProperties().getRecipesForLibrary(libName);
                if (recipes != null) {
                    Iterator rec = recipes.iterator();
                    while (rec.hasNext()) {
                    	lib = null;
                        try {
							lib = loader.getLibrary((String) rec.next());
						} catch (CPLException cplEx) {
							GUIUtils.userMessage(
									this,
									"Cannot load library " + rec + "\n" +
									cplEx.getMessage()
									);
						}
                        if (lib != null) {
                            plugins.add(lib);
                        }
                    }
                }
            }
        } catch (LTDLException e) {
            GUIUtils.userMessage(this, e.getMessage());
        } catch (Error e) {
            // it is not recommended to continue after catching an error
            // this catch statement displays a user message and exits
            e.printStackTrace();
            GUIUtils.userMessage(this, "Fatal Error", e.getMessage());
            System.exit(-1);
        }
        libs = new RecipeLibrary[plugins.size()];
        plugins.toArray(libs);

        RecipeSelector rsel = new RecipeSelector(libs) {
            protected void approveSelection() {
                Recipe recipe = getSelectedRecipe();
                frame.dispose();
                recipePanels.addRecipePanel(
                    recipe,
                    fsTree.getSelectedOBComponents(),
                    loader);
            }
            protected void cancelSelection() {
                frame.dispose();
            }
        };
        frame.getContentPane().add(rsel);
        frame.pack();
        GUIUtils.center(this, frame);
        frame.setVisible(true);

    }

    /**
     * Select and apply by default the first of the file filter rules used to 
     * build the filter builder widget of this class.
     */
    private void selectFirstFileFilter() {
        // This method has beeen added as part of fix of DFS02755.
        initfltBuilder(false); 
        if(fltBuilder == null)
        {
            return;
        }
        fltBuilder.selectFirstFilter();
        if (fltBuilder.getSelectedFilter() != null) {
            setFilter(fltBuilder.getSelectedFilter());
        }
    }
    
    
    /**
     * This method reads the filter rules from the filter rules file, specified 
     * in the preference file, and uses these rules to init the filter builder 
     * widget of this class.
     * If the filter rules file is not found, the behaviour depends on the 
     * input boolean: if set to true, it log a warnings and build a widget 
     * with no rules, otherwhise it does not build the widget and silently returns.
     * @param initAlways
     */
    private void initfltBuilder(boolean initAlways) {
            /* This method was part of the code of showExpressionBuilder, it has
             * been extracted as stand alone method as part of fix of DFS02755.
             */
    	
          if (fltBuilder == null) {
            String tablePath = null;
            ExpressionTable rt = null;
            tablePath =
                DirUtils.convertAbsoluteDir(
                    PropertyDB.getInstance().getProperty("FILTER_FILE"));
            if (tablePath != null) {
                rt = ExpressionTable.readFile(tablePath);
            }
            if (rt == null) {
                
                if (initAlways)
                {
                        if (PropertyDB
                        .getInstance()
                        .isDebug(PropertyDB.debugExpressionAndRules)) {
                        System.out.println(
                            "Failed to read/locate: "
                                + tablePath
                                + " starting with an empty table.");
                    }
                }
                else
                {
                    return;
                }
                rt = new ExpressionTable(tablePath);
            }
            fltBuilder =
                new FilterBuilder(
                    this,
                    "Filter Builder :" + tablePath,
                    true,
                    rt);
            fltBuilder.pack();
        }
    }
    
    /**
     * Action callback to display the expression builder.
     */
    private void showExpressionBuilder() {

        initfltBuilder(true); // DS FEB 2007 - DFS02755 (file filter on startup)
        
        Point p = getLocation();
        Dimension d = getSize();
        p.move(p.x + 100, p.y + d.height / 4);
        fltBuilder.setLocation(p);
        //fltBuilder.show();
        fltBuilder.setVisible(true);
        if (fltBuilder.getSelectedFilter() != null) {
            setFilter(fltBuilder.getSelectedFilter());
        }
    }

    /**
     * Set the specified OB Component filter onto the model.
     */
    private void setFilter(OBComponentFilter filter) {
        OBComponentFilter currentFilter = dataModel.getFileFilter();
        if (currentFilter != filter) {
            dataModel.setFileFilter(filter);
            if (currentFilter != null) {
                refreshModel();
            }
            if (filter != null) {
                Cursor c = getCursor();
                setCursor(waitCursor);
                ensureModelUpdatesComplete();
                new Thread(new Runnable() {
                    public void run() {
                        dataModel.applyFilter();
                    }
                }).start();
                setCursor(c);
            }
            // refresh the root label.
            fsTreeModel.setRootLabel(null);
            // refresh the tree
            fsTreeModel.updateTree();
            showBlankDetail(true);
            fsTree.getTree().expandRow(0);
        }
    }

    /**
     * Setup the file list pane.
     */
    private void setupFileListPane() {
        fileListPane = new FileListPane();

        fileListPane.addListSelectionListener(displayOrganizer);
        for (int i = 0; i < tabLabels.length; i++) {
            FileListModel lm =
                new FileListModel(null, tabLabels[i], emptyListLabels[i]);
            fileListPane.addList(lm);
        }
    }

    /**
     * all keyboard shortcuts are registered here<p>
     * All tests aimed at using the Alternate key have failed<p>,
     * waiting for JDK to fix this
     */
    private void registerKeyboard() {
        //KeyStroke AltQ = KeyStroke.getKeyStroke(KeyEvent.VK_Q, InputEvent.META_MASK,false);
        KeyStroke AltA =
            KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK, false);
        KeyStroke AltQ =
            KeyStroke.getKeyStroke(KeyEvent.VK_Q, InputEvent.CTRL_MASK, false);
        KeyStroke AltS =
            KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK, false);
        KeyStroke AltR =
            KeyStroke.getKeyStroke(KeyEvent.VK_R, InputEvent.CTRL_MASK, false);
        KeyStroke AltF =
            KeyStroke.getKeyStroke(KeyEvent.VK_F, InputEvent.CTRL_MASK, false);
        KeyStroke AltG =
            KeyStroke.getKeyStroke(KeyEvent.VK_G, InputEvent.CTRL_MASK, false);
        // very inefficient way to have keyboard shortcuts
        // lots of repetitions

        getRootPane().registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                System.exit(0);
            }
        }, AltQ, JComponent.WHEN_IN_FOCUSED_WINDOW);

        getRootPane().registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                toggleScriptBoard();
            }
        }, AltS, JComponent.WHEN_IN_FOCUSED_WINDOW);

        getRootPane().registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                generateReport();
            }
        }, AltR, JComponent.WHEN_IN_FOCUSED_WINDOW);

        getRootPane().registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                //
                if (dataModel.getFileFilter() == null) {
                    showExpressionBuilder();
                } else {
                    setFilter(null);
                }
            }
        }, AltF, JComponent.WHEN_IN_FOCUSED_WINDOW);

        getRootPane().registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                addFile();
            }
        }, AltA, JComponent.WHEN_IN_FOCUSED_WINDOW);

        getRootPane().registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                internalStatusReport();
                validate();
            }
        }, AltG, JComponent.WHEN_IN_FOCUSED_WINDOW);
    }

    /**
     * adds all menus and submenus for the MenuBar in one go<p>
     * Notice: if the order is changed, the method stateChanged must be 
     * modified as well<p>
     */

    private void addMenu() {

        JMenuBar mb = new JMenuBar();
        JMenu menu = new JMenu("File");

        JMenuItem mi = null;

        mi = new JMenuItem(addRmFileLabel);
        mi.addActionListener(this);
        menu.add(mi);

        final JCheckBoxMenuItem cbmi =
            new JCheckBoxMenuItem("Show Frame Assoc.");
        cbmi.setSelected(isShowFileLists());
        cbmi.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setShowFileLists(cbmi.isSelected());
            }
        });
        menu.add(cbmi);

        mi = new JMenuItem(addFilterLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(rmFilterLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(reclassifyLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(refreshLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(editPreferencesLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(quitLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mb.add(menu);

        mb.add(getSelectedFilesMenu());

        menu = new JMenu("Tools");

        mi = new JMenuItem(classBldrLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(kwListEditorLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(scriptBoardLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mb.add(menu);

        menu = new JMenu("Help");

        mi = new JMenuItem(overviewLabel);
        //	mi.setEnabled(false);
        mi.addActionListener(this);
        menu.add(mi);
        mi = new JMenuItem(initialSetupLabel);
        mi.addActionListener(this);
        menu.add(mi);
        mi = new JMenuItem(userInputLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(preferencesLabel);
        mi.addActionListener(this);
        menu.add(mi);

        mi = new JMenuItem(associationLabel);
        mi.addActionListener(this);
        menu.add(mi);
        mi = new JMenuItem(externalCommandsLabel);
        mi.addActionListener(this);
        menu.add(mi);

        //mi = new JMenuItem(databaseLabel);
        //mi.addActionListener(this);
        //menu.add(mi);

        //mi = new JMenuItem(whoIsGasganoLabel);
        //mi.addActionListener(this);
        //menu.add(mi);
        // mb.setHelpMenu(menu); 
        mb.add(menu);

        setJMenuBar(mb);
    }

    /**
     * Static utility method to initialize two menus (one for adding frames to
     * an new or existing recipe, one for queue frames on an existing recipe panel.
     * 
     * The utility method is used as the calls are made multiple times - once to build
     * the menu for the menu bar, the other for the menus in the popup menu.
     * @param recipeMenu
     * @param queueMenu
     */
    private void setupRecipePanelMenus(
        final JMenu recipeMenu,
        final JMenu queueMenu) {
        final ActionListener loadRecipeAction = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                showRecipePanel(e.getActionCommand());
            }
        };
        final JMenu openRecipeMenu = new JMenu(openRecipeLabel);
        // build up a list of all the recipe names, adding the names
        // to a list, then sort the list before creating the
        // menu items for the list.
        List recipeNames = new ArrayList();
        Iterator i = GasProp.getProperties().getRecipeLibraryNames();
        while (i.hasNext()) {
            String libName = (String) i.next();
            List recipes =
                GasProp.getProperties().getRecipesForLibrary(libName);
            if (recipes != null) {
                Iterator rec = recipes.iterator();
                while (rec.hasNext()) {
                    String name = (String) rec.next();
                    recipeNames.add(name);
                }
            }
        }
        Collections.sort(recipeNames);
        Iterator r = recipeNames.iterator();
        while (r.hasNext()) {
            String name = (String)r.next();
            //
            // initialize the menu bar menu items.
            JMenuItem recMi = new JMenuItem(name);
            recMi.addActionListener(loadRecipeAction);
            openRecipeMenu.add(recMi);
        }

        // disable this menu if it is empty.
        openRecipeMenu.setEnabled(openRecipeMenu.getItemCount() > 0);

        final ActionListener addFramesToRecipeAction = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                addSelectedFilesToRecipePanel(e.getActionCommand(), false);
            }
        };

        final ActionListener addFramesToQueueAction = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                addSelectedFilesToRecipePanel(e.getActionCommand(), true);
            }
        };

        recipeMenu.add(openRecipeMenu);
        recipeMenu.setEnabled(recipeMenu.isEnabled());
        queueMenu.setEnabled(false);

        recipePanels.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                rebuildMenu(recipeMenu, addFramesToRecipeAction);
                rebuildMenu(queueMenu, addFramesToQueueAction);
                recipeMenu.add(openRecipeMenu);
                // if the recipePanelMenu is disabled and it is the only
                // menu item in the recipePanelMenu, then disable that menu as well.
                recipeMenu.setEnabled(
                    openRecipeMenu.isEnabled()
                        || recipeMenu.getMenuComponentCount() > 1);
                queueMenu.setEnabled(queueMenu.getMenuComponentCount() > 0);
            }

            /*
             * Utility method to rebuild menus based on open recipe panels.
             */
            private void rebuildMenu(JMenu menu, ActionListener listener) {
                //menu.removeAll();
                while (menu.getMenuComponentCount() > 0) {
                    menu.remove(0);
                }
                Iterator i = recipePanels.getRecipePanelNames();
                while (i.hasNext()) {
                    String name = (String) i.next();
                    CPLFrame recipePanel =
                        (CPLFrame) recipePanels.getRecipePanel(name);
                    JMenuItem panelMItem = new JMenuItem(name);
                    panelMItem.addActionListener(listener);
                    menu.add(panelMItem);
                }
            }
        });
    }

    /**
     * Initialize and return the selected files menu - also the 
     * selectedFilesPopupMenu is initialized with the same menu items.
     * @return JMenu
     */
    private JMenu getSelectedFilesMenu() {
        //JMenuItem mi;
        Action action;
        JMenu selectedFilesMenu = new JMenu("Selected files");
        selectedFilesPopupMenu = new JPopupMenu();

        action = new AbstractAction(externalViewerLabel) {
            public void actionPerformed(ActionEvent e) {
                treeControlPanel.callExternalViewer();
            }
        };

        selectedFilesMenu.add(new JMenuItem(action));
        selectedFilesPopupMenu.add(new JMenuItem(action));

        // create and setup the recipe and queue menus for the menu bar.
        final JMenu recipePanelMenu = new JMenu(toRecipeLabel);
        final JMenu queuePanelMenu = new JMenu(toQueueLabel);
        setupRecipePanelMenus(recipePanelMenu, queuePanelMenu);
        selectedFilesMenu.add(recipePanelMenu);
        selectedFilesMenu.add(queuePanelMenu);

        // create and setup the recipe and queue menus for the popup menu.
        final JMenu recipePanelPopupMenu = new JMenu(toRecipeLabel);
        final JMenu queuePanelPopupMenu = new JMenu(toQueueLabel);
        setupRecipePanelMenus(recipePanelPopupMenu, queuePanelPopupMenu);
        selectedFilesPopupMenu.add(recipePanelPopupMenu);
        selectedFilesPopupMenu.add(queuePanelPopupMenu);

        action = new AbstractAction(reportFileLabel) {
            public void actionPerformed(ActionEvent e) {
                generateReport();
            }
        };
        selectedFilesMenu.add(new JMenuItem(action));
        selectedFilesPopupMenu.add(new JMenuItem(action));

        action = new AbstractAction(mvFileLabel) {
            public void actionPerformed(ActionEvent e) {
                copySelectedFiles(true);
            }
        };
        selectedFilesMenu.add(new JMenuItem(action));
        selectedFilesPopupMenu.add(new JMenuItem(action));

        action = new AbstractAction(cpFileLabel) {
            public void actionPerformed(ActionEvent e) {
                copySelectedFiles(false);
            }
        };
        selectedFilesMenu.add(new JMenuItem(action));
        selectedFilesPopupMenu.add(new JMenuItem(action));

        action = new AbstractAction(tarFileLabel) {
            public void actionPerformed(ActionEvent e) {
                tarSelectedFiles();
            }
        };
        selectedFilesMenu.add(new JMenuItem(action));
        selectedFilesPopupMenu.add(new JMenuItem(action));

        action = new AbstractAction(appFileLabel) {
            public void actionPerformed(ActionEvent e) {
                selectedFilesToCommand(null, true, false, false);
            }
        };
        selectedFilesMenu.add(new JMenuItem(action));
        selectedFilesPopupMenu.add(new JMenuItem(action));

        return selectedFilesMenu;
    }
    
    /**
     * Convenience method to load the rule file from disk and update the classifier.
     * @return True if successful, false otherwise.
     */
    private boolean loadAndUpdateClassifier(String ruleFile) {
    	
    	boolean retVal = false;
    	
        try {
			dataModel.setClassifier(
					DFSDataModel.createClassifier(
							new FileInputStream(ruleFile)
						)
					);
			
			retVal = true;
			
		} catch (FileNotFoundException e) {
            GUIUtils.userMessage(
                    this,
                    "Unable to access rules file [" + ruleFile + "].\n" + e.getMessage());
		} catch (ParseException e) {
			GUIUtils.userError(this, "The rule file contains errors: \n\n" + e.getMessage());
		} catch(Exception e) {
            GUIUtils.userMessage(
                    this,
                    "Unexpected exception while accessing rules file [" + ruleFile + "].\n" + e.getMessage());
		} catch(Error e) {
            GUIUtils.userMessage(
                    this,
                    "Unexpected error while accessing rules file [" + ruleFile + "].\n" + e.getMessage());
		}
		
		return retVal; 
    }

    /**
     * Reclassify all files in the model.
     */
    private void reclassifyModel() {
        Cursor c = getCursor();
        setCursor(waitCursor);
        dataModel.reclassify();
        setCursor(c);
        fsTreeModel.updateTree();
        showBlankDetail(true);
        // tree.getTree().expandRow(0);
    }

    /**
     * A busy wait, sleeping until the data model has completed
     * any current updates.
     */
    private void ensureModelUpdatesComplete() {
        // if the model is currently updating, then wait.
        while (dataModel.isUpdating()) {
            try {
                // sleep for 10ms to ease the busy wait.
                Thread.sleep(10);
            } catch (InterruptedException e) {
                // do nothing.
            }
        };
    }

    /**
     * check the semaphore and call the 
     * update method of the DataModel<p>
     * meant to be used by the update timer
     */
    private void refreshModelWithoutWindow() {
        if (!dataModel.isUpdating()) {
            new Thread(new Runnable() {
                public void run() {
                    dataModel.update(dataModel.getFileSet());
                }
            }).start();
        }
    }
    
    private void refreshModel() {
    	refreshModel(true);
    }

    /**
     * spawns a DataModelBuilder window<p>
     * meant to be used by the user manually
     */
    private void refreshModel(boolean visible) {
        Point topLeft = getLocation();
        Dimension size = getSize();
        if (!dataModel.isUpdating()) {
            DataModelBuilder updater =
                new DataModelBuilder(
                    dataModel,
                    this,
                    "Updating data from disk",
                    true);
            // center the dialog over the main frame.
            topLeft.move(
                topLeft.x + size.width / 2 - 150,
                topLeft.y + size.height / 3);
            updater.setLocation(topLeft);
            updater.initTask();
            updater.pack();
            // this is a little dirty; it would be better to use
            // refreshModelWithoutWindow(), but it doesn't really
            // do what it should
            if(visible) {
            	updater.setSize(300, 250);            	
            } else {
            	updater.setSize(0, 0);
            }
            updater.setVisible(true);
            showBlankDetail(true);
            fsTree.getTree().expandRow(0);
        }
    }

    /**
     * Display a blank detail panel and possibly clean the tree
     * selection.
     * @param clearSelection
     */
    public void showBlankDetail(boolean clearSelection) {
        if (blankDetail == null) {
            blankDetail = new JPanel();
            //blankDetail.setPreferredSize(new Dimension(500, 500));
        }
        fileListPane.emptyLists();
        setDetailComponent(blankDetail);
        if (clearSelection) {
            displayOrganizer.clearTreeSelection();
        }
    }

    /**
     * Callback method for Add Files. Presents the FileListChooser
     * allowing the user to edit the file set.
     * The model is the rebuilt if there are changes.
     */
    private void addFile() {
        boolean timerOn = false;
        Vector currentSelection = new Vector();
        // add our existing set.
        String dirs[] = fileSelections.getDirs();
        if (updateTimer.isRunning()) {
            timerOn = true;
            updateTimer.stop();
        }

        for (int i = 0; i < dirs.length; i++) {
            currentSelection.addElement(dirs[i]);
        }
        if (fileListChooser == null) {
            fileListChooser = new FileListChooser();
        }
        fileListChooser.setFileList(currentSelection);
        if (JOptionPane
            .showConfirmDialog(
                this,
                fileListChooser,
                "Edit directory set" + ((timerOn) ? " / Timer suspended" : ""),
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.PLAIN_MESSAGE)
            == JOptionPane.OK_OPTION) {
            currentSelection = fileListChooser.getFileList();
            dirs = new String[currentSelection.size()];
            for (int i = 0; i < currentSelection.size(); i++) {
                dirs[i] = (String) currentSelection.elementAt(i);
            }
            ensureModelUpdatesComplete();
            updateFileSelectionAndRefresh(dirs, true);
        }
        if (timerOn) {
            updateTimer.restart();
        }
    }
    
    /**
     * Convenience method calling two methods that are often used
     * together.
     * @param dirs
     */
    private void updateFileSelectionAndRefreshQuietly(
        String[] dirs,
        boolean replace) {
        updateFileSelection(dirs, replace);
        refreshModel(false);
    }

    /**
     * Convenience method calling two methods that are often used
     * together.
     * @param dirs
     */
    private void updateFileSelectionAndRefresh(
        String[] dirs,
        boolean replace) {
        updateFileSelection(dirs, replace);
        refreshModel();
    }

    /**
     * Replace the file set in teh data model, but do not
     * refresh the datamodel.
     * @param dirs
     */
    private void replaceFileSelection(String[] dirs) {
        updateFileSelection(dirs, true);
    }

    /**
     * replace the file selection model with a new set of files. If replace
     * is true, the new model contains only the files in the dires parameter,
     * otherwise the files in the dires parameter are added to the existing
     * set.
     */
    private void updateFileSelection(String[] dirs, boolean replace) {
        Vector existingDirs;
        if (replace) {
            existingDirs = new Vector();
        } else {
            existingDirs = fileSelections.getFileList();
        }
        String newDirs[] = new String[dirs.length + existingDirs.size()];
        int newDirIdx = 0;
        // add existing files set, if any
        try {

            for (int i = 0; i < existingDirs.size(); i++, newDirIdx++) {
                newDirs[newDirIdx] = (String) existingDirs.elementAt(i);
            }
            // add the new file set.
            for (int i = 0; i < dirs.length; i++, newDirIdx++) {
                newDirs[newDirIdx] = dirs[i];
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        // replace the fileSelections file selection model in the dataModel.
        dataModel.removeFileSelectionModel(fileSelections);
        try {
			fileSelections = new DirectoryFileSelectionModel(newDirs);
		} catch (IOException ioe) {
			final String errMsg = (ioe.getMessage().length() > 500 ? ioe.getMessage().substring(0, 500) + "[...]" : ioe.getMessage()); 
			GUIUtils.userMessage(
					this,
					"One or more errors found while initializing DirectoryFileSelectionModel: " +
					errMsg
					);
		}
        dataModel.addFileSelectionModel(fileSelections);
    }

    /**
     * returns a file chooser onto the script directory<br>
     * specified in the preferences
     * @param: all the specific features of a JFileChooser
     */
    private JFileChooser getFileChooser(
        int selectionType,
        int dialogType,
        String textMsg,
        String approveMsg) {
        if (fileChooser == null) {
            String scriptDir =
                new String(
                    System.getProperties().getProperty("user.home")
                        + File.separator
                        + PropertyDB.getInstance().getProperty("SCRIPTS_DIR"));
            fileChooser = new SwingFileChooser(new File(scriptDir));
        } else {
            fileChooser.rescanCurrentDirectory();
        }
        fileChooser.setFileSelectionMode(selectionType);
        fileChooser.setDialogType(dialogType);
        fileChooser.setDialogTitle(textMsg);
        fileChooser.setApproveButtonText(approveMsg);
        fileChooser.setMultiSelectionEnabled(false);
        return fileChooser;
    }

    /**
     * pops up a window to choose which command should be applied on which files
     * @param: filePath, when available, confirm on/off, supply classification on/off<p>
     * background on/off.
     */
    public void selectedFilesToCommand(
        String filePath,
        boolean confirm,
        boolean classSupply,
        boolean backGround) {
        Vector files = fsTree.getSelectedFiles();
        String selectedDir = fsTree.getSelectedDir();
        String selectedExe = null;

        if (files.size() == 0 && selectedDir == null) {
            GUIUtils.userMessage(this, "No files have been selected.");
            return;
        }

        if (filePath == null) { // need to pop up a file chooser
            JFileChooser exeChooser =
                getFileChooser(
                    JFileChooser.FILES_ONLY,
                    JFileChooser.OPEN_DIALOG,
                    "Select application to run",
                    "OK");
            if (exeChooser.showOpenDialog(this)
                == JFileChooser.APPROVE_OPTION) {
                if (exeChooser.getSelectedFile() != null) {
                    selectedExe = exeChooser.getSelectedFile().getPath();
                }
            }
        } else {
            selectedExe = filePath;
        }
        // the name of the executable is known here and all the checks have been
        // made

        // dont show the user more than this number in the file display list
        // as the pop-up will go off the bottom of the page.
        int maxFileNamesToDisplay = 15;

        if (selectedExe != null) {
            StringBuffer command = new StringBuffer();
            StringBuffer displayCommand = new StringBuffer();
            // "/usr/bin/sh -e "+
            if (backGround) {
                command.append("/usr/bin/sh -e '( ");
            }
            command.append(selectedExe);
            displayCommand.append(command.toString());
            if (files.size() == 0) {
                command.append(" " + selectedDir);
                displayCommand.append(" " + selectedDir + "\n");
            } else {
                String[] fileNames = new String[files.size()];
                for (int i = 0; i < files.size(); i++) {
                    fileNames[i] = files.elementAt(i).toString();
                }
                Sorting.sort(fileNames, 0, fileNames.length);

                for (int i = 0; i < files.size(); i++) {
                    command.append(" " + fileNames[i]);
                    if (i < maxFileNamesToDisplay) {
                        displayCommand.append("\n" + fileNames[i]);
                    } else if (i == maxFileNamesToDisplay) {
                        displayCommand.append(
                            ("\n...(total " + files.size() + " files)."));
                    }
                    if (classSupply) {
                        String comp = fileNames[i];
                        String classification =
                            dataModel.getClassificationForName(comp);
                        command.append(" " + classification);
                        displayCommand.append(" " + classification);
                    }
                }
            }
            if (backGround) {
                command.append(" )' &");
                displayCommand.append(" )' &");
            }

            if (confirm) {
                if (JOptionPane
                    .showConfirmDialog(
                        this,
                        displayCommand.toString(),
                        "Run the following command?",
                        JOptionPane.YES_NO_OPTION)
                    == JOptionPane.YES_OPTION) {
                    GUIUtils.runCommandInGui(this, command.toString(), 0);
                }
            } else {
                GUIUtils.runCommandInGui(this, command.toString(), 0);
            }

        }
    }

    private void addFileToSelection(String filePath) {
        if (!fileSelectionExists(filePath)) {
            int numDirs = fileSelections.getDirs().length;
            String dirs[] = new String[numDirs + 1];
            System.arraycopy(fileSelections.getDirs(), 0, dirs, 0, numDirs);
            dirs[numDirs] = filePath;
            replaceFileSelection(dirs);
        }
    }

    /**
     * Return a PasswordSource object for accessing password information        	 
     * (prompted from the user via a dialog.
     */
    public PasswordSource getPasswordSource() {
        return new PasswordPrompt(this);
    }

    /**
     * returns true if the given directory is 
     * already in the current data-set
     */
    private boolean fileSelectionExists(String file) {
        boolean rc = false;
        String[] dirs = fileSelections.getDirs();
        for (int i = 0; i < dirs.length && !rc; i++) {
            if (dirs[i].equals(file)) {
                rc = true;
            }
        }
        return rc;
    }

    /**
     * The tar command is not conventional - it has been structured to
     * fail when the device is full, instead of prompting stdin for the
     * next device. This is done by tarring to stdout and piping the 
     * data to the dd command.
     */
    private void tarSelectedFiles() {
        String selectedTarFile = null;
        JFileChooser tarChooser =
            getFileChooser(
                JFileChooser.FILES_ONLY,
                JFileChooser.OPEN_DIALOG,
                "Enter destination TAR file",
                "tar");
        Vector files = fsTree.getSelectedFiles();
        if (files.size() == 0) {
            GUIUtils.userMessage(this, "No files have been selected.");
            return;
        }

        if (tarChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            if (tarChooser.getSelectedFile() != null) {
                selectedTarFile = tarChooser.getSelectedFile().getPath();
                StringBuffer command = new StringBuffer();

                if (System
                    .getProperties()
                    .getProperty("os.name")
                    .equals("HP-UX")) {
                    //command.append("sh eval tar -cbf 20 -");
                    command.append("tar -cbf 20 " + selectedTarFile + " ");
                } else {
                    command.append("tar -cf " + selectedTarFile + " ");
                    //command.append("sh -c '/usr/bin/tar -cbf 20 -");
                }

                for (int i = 0; i < files.size(); i++) {
                    File file = new File(files.elementAt(i).toString());
                    command.append(
                        " -C " + file.getParent() + " " + file.getName());
                }

                GUIUtils.runCommandInGui(this, command.toString(), 0);
                // System.out.println(command.toString());
            }
        }
    }

    /**
     * one method is used both for copying and for moving files<p>
     * This method pops up a chooser window for the destination directory<p>
     * In case of 'move' the directory is added to the data-set in memory
     */
    private void copySelectedFiles(boolean move) {
        JFileChooser cpMvChooser = null;
        String selectedDir = null;
        Vector files = fsTree.getSelectedFiles();
        if (files.size() == 0) {
            GUIUtils.userMessage(this, "No files have been selected.");
            return;
        }
        if (move) {
            cpMvChooser =
                getFileChooser(
                    JFileChooser.DIRECTORIES_ONLY,
                    JFileChooser.OPEN_DIALOG,
                    "Select target directory for move.",
                    "Move");
        } else {
            cpMvChooser =
                getFileChooser(
                    JFileChooser.DIRECTORIES_ONLY,
                    JFileChooser.OPEN_DIALOG,
                    "Select target directory for copy.",
                    "Copy");
        }
        if (cpMvChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            if (cpMvChooser.getSelectedFile() != null) {
                File tmpFile = cpMvChooser.getSelectedFile();
                if (!tmpFile.canWrite()) {
                    GUIUtils.userMessage(
                        this,
                        "The directory "
                            + tmpFile.getPath()
                            + "\nis not writable");
                    return;
                }
                selectedDir = cpMvChooser.getSelectedFile().getPath();
                StringBuffer command = new StringBuffer();
                if (move) {
                    command.append("mv");
                } else {
                    command.append("cp");
                }
                for (int i = 0; i < files.size(); i++) {
                    command.append(" " + files.elementAt(i).toString());
                }
                command.append(" " + selectedDir);
                if (files.size() == 0) {
                    GUIUtils.userMessage(this, "No files selected");
                } else if (selectedDir.length() == 0) {
                    GUIUtils.userMessage(this, "No target directory selected");
                } else {
                    GUIUtils.runCommandInGui(this, command.toString(), 0);
                    if (move) {
                        addFileToSelection(selectedDir);
                        refreshModel();
                    }
                }
            }
        }
    }
    /**
     * instantiates new KeywordListLoader, FitsFileReport and ReportViewer,
     * pops up a window to choose the keyword list file
     */
    public void generateReport() {
        Vector files = null;
        Vector keywords = null;
        Vector columns = null;
        Enumeration myEnum = null;
        Cursor currentCursor = getCursor();
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        if (fsSelected) {
            files = fsTree.getSelectedOBComponents();
        } else {
            files = dbTree.getSelectedOBComponents();
        }
        for (int i = files.size() - 1; i >= 0; i--) {
            if (files.elementAt(i) instanceof DBOBComponent) {

            } else {
                OBComponent obc = (OBComponent) files.elementAt(i);
                if ((obc instanceof KeywordContainerOBComponent) == false) {
                    files.removeElementAt(i);
                } else {
                    files.setElementAt(obc.getSourceFile(), i);
                }
            }
        }
        if (files.size() == 0) {
            GUIUtils.userMessage(this, "No FITS files have been selected.");
            // display the original cursor
            setCursor(currentCursor);
            return;
        }
        if (kwListLoader == null) {
            kwListLoader = new KeywordListLoader();
        }
        if (JOptionPane
            .showConfirmDialog(
                this,
                kwListLoader,
                "Load keyword list",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.PLAIN_MESSAGE)
            == JOptionPane.OK_OPTION) {
            keywords = kwListLoader.getKeywordTable().getKeywordList();
            columns = kwListLoader.getKeywordTable().getKeywordLabelList();
            // replace any empty column names with the keyword names.
            for (int i = 0; i < keywords.size(); i++) {
                String colName = (String) columns.elementAt(i);
                if (colName == null || colName.length() == 0) {
                    columns.setElementAt(keywords.elementAt(i), i);
                }
            }
        }
        if (keywords != null) {
            FitsFileReport rep = new FitsFileReport(files, keywords, columns);
            ReportViewer viewer =
                new ReportViewer("Report of selected selected files", rep);
            viewer.pack();
            viewer.setSize(1100, 500);
            // move it away from the top LH corner.
            viewer.setLocation(100, 300);
            viewer.setVisible(true);
        }
        // display the original cursor
        setCursor(currentCursor);
    }

    /**
     * to be called by the GasPropEditor, this method
     * removes all file selections and updates the DataModel
     */
    public void unLoadAll() {
        try {
			backupFileSelections =
			    new DirectoryFileSelectionModel(fileSelections.getDirs());
		} catch (IOException ioe) {
			final String errMsg = (ioe.getMessage().length() > 500 ? ioe.getMessage().substring(0, 500) + "[...]" : ioe.getMessage()); 
			GUIUtils.userMessage(
					this,
					"One or more errors found while initializing DirectoryFileSelectionModel: " +
					errMsg
					);
		}
        updateFileSelectionAndRefreshQuietly(new String[0], true);
        ensureModelUpdatesComplete();
    }

    public void reLoadPrevious() {
        dataModel.addFileSelectionModel(backupFileSelections);
        fileSelections = backupFileSelections;
        refreshModel();
    }

    /**
     * Callback for the GasPropListener interface. This method is called
     * when the properties have been edited.
     * This method adds additional settings to the property set overrriding those
     * in the GasProp instance.
     * the following properties are taken care of by this method:
     * FRAME_BOUNDS , DATA_FILES, DISPLAY_COLUMNS
     * DBOBS_DISPLAY_COLUMNS, VERBOSE_LEVEL, UPDATE_TIMER
     * SHORT_FILENAME, RADEC_CONVERSION, OB_STATUS_FROM_DB_REQUIRED
     * DBOBS_REQUIRED
     * @see: GasPropEditor.
     */
    public void newProperties(boolean shutdown) {
        int debugLev = 0;
        int updateMinutes = 0;
        boolean refresh = false;
        boolean refreshTable = false;
        String tmpString = null;
        Cursor c = getCursor();
        Vector desiredSel = null;

        if (shutdown) {
            unLoadAll();
        }

        // here we de-facto update the preferences
        // all following queries will deliver new values
        //actualPrefs.copyFrom(gpx);
        //actualPrefs.buildVectors();

        if (shutdown) {
            reLoadPrevious();
        }
        GasProp newInstance = GasProp.getProperties();
        // window dimensions
        newInstance.put("FRAME_BOUNDS", GUIUtils.rectToString(getBounds()));
        if (!newInstance.saveProperties()) {
            GUIUtils.userMessage(
                this,
                "Failed to save preferences file: "
                    + newInstance.getSourceFile()
                    + ".");
        }

        setCursor(waitCursor);

        desiredSel =
            GasProp.stringScanner(newInstance.getProperty("DATA_FILES"), ';');
        // DATA_FILES
        if ((desiredSel != null)
            && ((backupPrefs.getProperty("DATA_FILES") == null)
                || !newInstance.getProperty("DATA_FILES").equals(
                    backupPrefs.getProperty("DATA_FILES")))) {
            Vector currentSel = new Vector();

            for (int i = 0; i < desiredSel.size(); i++) {
                File tmpF = new File((String) desiredSel.elementAt(i));
                try {
                    desiredSel.setElementAt(tmpF.getCanonicalPath(), i);
                } catch (IOException ioe) {
                    desiredSel.removeElementAt(i);
                }
            }

            // add our existing set.
            String dirs[] = fileSelections.getDirs();
            for (int i = 0; i < dirs.length; i++) {
                currentSel.addElement(dirs[i]);
            }
            // now currentSel is a vector containing the dirs 
            // currently in memory 

            // we rely upon the vectos' string representation
            if (!desiredSel.toString().equals(currentSel.toString())) {
                currentSel = desiredSel;
                dirs = new String[currentSel.size()];
                for (int i = 0; i < currentSel.size(); i++) {
                    dirs[i] = (String) currentSel.elementAt(i);
                    replaceFileSelection(dirs);
                    refresh = true;
                }
            }
        }

        // FILESYSTEM DISPLAY COLUMNS
        if (!PropertyDB
            .getInstance()
            .getProperty("DISPLAY_COLUMNS")
            .equals(backupPrefs.getProperty("DISPLAY_COLUMNS"))) {
            Vector displayCols = GasProp.getProperties().fsDisplayColumns;
            Keyword[] cols = new Keyword[displayCols.size()];
            for (int i = 0; i < cols.length; i++) {
                cols[i] = new Keyword((String) displayCols.elementAt(i), null);
            }
            dataModel.setDefaultFileDescription(new BasicFileDescription(cols));
            dataModel.resetDescription();
            //System.out.println("DISPLAY_COLUMNS refresh true, refreshTable true");
            refresh = true;
            refreshTable = true;
        }

        // DATABASE DISPLAY COLUMNS
        if (!PropertyDB
            .getInstance()
            .getProperty("DBOBS_DISPLAY_COLUMNS")
            .equals(backupPrefs.getProperty("DBOBS_DISPLAY_COLUMNS"))
            && safeEnvironment) {

            Vector displayCols = GasProp.getProperties().dbDisplayColumns;
            Keyword[] cols = new Keyword[displayCols.size()];
            for (int i = 0; i < cols.length; i++) {
                cols[i] = new Keyword((String) displayCols.elementAt(i), null);
            }

            dbDataModel.setDefaultFileDescription(
                new BasicFileDescription(cols));
            setDatabasePanelEnabled(false);

            dbTreeModel.toggleColumn();
            if (dbTreeModel.periodSelectionChanged()) {
                setDatabasePanelEnabled(true);
            }
            dbTreeModel.updateTree();
            ((AbstractTableModel) dbTree.getModel())
                .fireTableStructureChanged();
            dbTree.setColumnWidths();
            //System.out.println("DBOBS_DISPLAY_COLUMNS refresh true, refreshTable true");
        }
        
	
        // this for the classification rules file
        tmpString = PropertyDB.getInstance().getProperty("CLASSRULE_FILE");
        if ( !backupPrefs.getProperty("CLASSRULE_FILE").toString()
        	 .equals(tmpString) ) {
        	
            if (tmpString != null) {
                loadAndUpdateClassifier(tmpString);
            }
        }
        
        // -- start of fix for DFS03630
        //
        // This is to load and apply the new filter file specified by the user
        // on the fly, without the need to restart Gasgano.
        //
        tmpString = PropertyDB.getInstance().getProperty("FILTER_FILE");
        if (!backupPrefs
            .getProperty("FILTER_FILE")
            .toString()
            .equals(tmpString)) {
        	
            	if (tmpString != null) {
            		fltBuilder = null;
            		this.initfltBuilder(true);
                }
        }
        // -- end of fix for DFS03630
        

        // this for the Debug Level
        tmpString = PropertyDB.getInstance().getProperty("VERBOSE_LEVEL");
        if (tmpString != null) {
            debugLev = Integer.parseInt(tmpString);
            PropertyDB.getInstance().setDebugLevel(debugLev);
        }

        // this for the Update Timer
        tmpString = PropertyDB.getInstance().getProperty("UPDATE_TIMER");
        if (tmpString != null) {
            updateMinutes = Integer.parseInt(tmpString);
            if (updateTimer.getDelay() != (updateMinutes * 60000)) {
                updateTimer.stop();
                updateTimer.setDelay(updateMinutes * 60000);
                if (updateMinutes != 0) {
                    updateTimer.restart();
                }
            }
        }

        // this is for the Short Name feature of the OBCOmponent
        tmpString = PropertyDB.getInstance().getProperty("SHORT_FILENAME");
        if (!backupPrefs
            .getProperty("SHORT_FILENAME")
            .toString()
            .equals(tmpString)) {
            if (tmpString.equals("true")) {
                OBComponent.setShortName(true);
            } else {
                OBComponent.setShortName(false);
            }
            // System.out.println("SHORT_FILENAME refresh true, refresh table true");
            fsTreeModel.updateTree();
            refresh = true;
            refreshTable = true;
        }

        tmpString = PropertyDB.getInstance().getProperty("RADEC_CONVERSION");
        if (!backupPrefs
            .getProperty("RADEC_CONVERSION")
            .toString()
            .equals(tmpString)) {
            if (tmpString.equals("true")) {
                FitsFile.setRadecConversion(true);
            } else {
                FitsFile.setRadecConversion(false);
            }
            // System.out.println("RADEC_CONVERSION refresh true, table true");
            dataModel.resetDescription();
            fsTreeModel.updateTree();
            refresh = true;
            refreshTable = true;
        }

        tmpString =
            PropertyDB.getInstance().getProperty("OB_STATUS_FROM_DB_REQUIRED");
        if (!backupPrefs
            .getProperty("OB_STATUS_FROM_DB_REQUIRED")
            .toString()
            .equals(tmpString)) {
            GUIUtils.userMessage(
                this,
                "You will have to restart the application for the OB STATUS change to take place");
        }

        if (safeEnvironment) {
            tmpString = PropertyDB.getInstance().getProperty("DBOBS_REQUIRED");
            if (!backupPrefs.getProperty("DBOBS_REQUIRED").equals(tmpString)) {
                if (tmpString.equals("true")) {
                    setDatabaseEnabled(true);
                } else {
                    setDatabaseEnabled(false);
                }
            }
        }

        if (refresh) {
            refreshModel();
        }
        if (refreshTable) {
            fsTreeModel.toggleColumn();
            AbstractTableModel tModel = (AbstractTableModel) fsTree.getModel();
            tModel.fireTableStructureChanged();
            fsTree.setColumnWidths();
        }
        setCursor(c);
        backupPrefs = null;
    }

    /**
     * this method is used to load the DATA_FILES which might be specified in the
     * preferences into the dataModel at application start-up time
     * @author: Michele Zamparelli
     */
    public void initializeFileSelections() {
        String dirsString = new String();
        Vector dirsVector = null;
        dirsString = PropertyDB.getInstance().getProperty("DATA_FILES");
        if (dirsString == null) {
            return;
        }
        dirsVector = GasProp.stringScanner(dirsString, ';');
        if (dirsVector.size() == 0) {
            return;
        }
        for (int i = 0; i < dirsVector.size(); i++) {
            File tmpF = new File((String) dirsVector.elementAt(i));
            if (!(tmpF.exists()
                && tmpF.isDirectory()
                && tmpF.isAbsolute()
                && tmpF.canRead())) {
                dirsVector.removeElementAt(i);
            } else {
                try {
                    dirsVector.setElementAt(tmpF.getCanonicalPath(), i);
                } catch (IOException ioe) {
                    // what do I do here ?
                }
            }

        }
        String[] dirs = new String[dirsVector.size()];
        for (int i = 0; i < dirs.length; i++) {
            dirs[i] = (String) dirsVector.elementAt(i);
        }
        updateFileSelectionAndRefresh(dirs, true);
    }

    /**
     * particularization: as hoc method to call 
     * a binary to retrieve some files from the Archive database
     */
    public void retrieveFilesFromDb(final Enumeration ee) {
        if (retrieveFileChooser == null) {
            retrieveFileChooser =
                getFileChooser(
                    JFileChooser.DIRECTORIES_ONLY,
                    JFileChooser.OPEN_DIALOG,
                    "Select  Destination Directory ",
                    "Retrieve");
        }
        if (retrieveFileChooser.showOpenDialog(this)
            == JFileChooser.APPROVE_OPTION) {
            new Thread(new Runnable() {
                public void run() {
                    int rc =
                        FileDownloader.retrieveFilesFromDb(
                            ee,
                            retrieveFileChooser.getSelectedFile().getPath());
                    if (rc != 0) {
                        GUIUtils.userMessage(
                            GasganoDisplay.this,
                            "Retrieve failed!");
                    }
                }
            }).start();
        }
    }

    /**
     * this method needs to be here just because
     * of the ScriptDirBoard
     */
    public boolean isModelEmpty() {
        return dataModel.isModelEmpty();
    }

    /**
     * Debug/report utility method.
     */
    public static void internalStatusReport() {
        Runtime r = Runtime.getRuntime();
        System.out.print(
            "Memory: Total/Free " + r.totalMemory() + " / " + r.freeMemory());
        DFSDataModel.getDataModel().displayHashtableSizes();
        System.out.println(
            "Header Read "
                + FitsFile.readHeaderNumber
                + " in Avg: "
                + (double) FitsFile.readHeaderTime
                    / (double) FitsFile.readHeaderNumber
                + "ms");
        
        // TODO: wanna provide an alternative for this ?
//        System.out.println(
//            "Classified "
//                + FitsFile.classificationNumber
//                + " in Avg: "
//                + (double) FitsFile.classificationTime
//                    / (double) FitsFile.classificationNumber
//                + " ms with "
//                + DFSDataModel.getDataModel().getRuleTable().getRowCount()
//                + " rules");
        
        System.out.println(
            "Overall read "
                + KeywordContainerOBComponent.initNumber
                + " in Avg: "
                + (double) KeywordContainerOBComponent.initTime
                    / (double) KeywordContainerOBComponent.initNumber
                + " ms");
        System.out.println("");
    }

    /**
     * Set the specified component into the JSplitPane containing
     * the detail panel - the current detail component will be removed,
     * if present.
     * @param detail
     */
    private void setDetailComponent(JComponent detail) {
        Cursor c = getCursor();
        setCursor(waitCursor);
        JSplitPane spane = getDetailPanelContainer();
        int currentLoc = spane.getDividerLocation();
        if (spane.getBottomComponent() != null) {
            spane.remove(spane.getBottomComponent());
        }
        detail.setPreferredSize(new Dimension(100, 100));
        spane.setBottomComponent(detail);
        spane.setDividerLocation(currentLoc);
        // no longer required for java 1.4
        //spane.validate();
        //splitPane.validate();
        setCursor(c);
    }

    /**
     * Show or hide the file lists panel - modifying the splitPane
     * and lowerSplit pane accordingly.
     * @param hide
     */
    private void setHideFileListPanel(boolean hide) {

    }

    /**
     * Returns the showFileLists property - used to determine if the
     * middle panel (file lists) is to be displayed or not.
     * @return boolean
     */
    public boolean isShowFileLists() {
        return showFileLists;
    }

    /**
     * Sets the showFileLists.
     * @param showFileLists The showFileLists to set
     */
    private void setShowFileLists(boolean b) {
        if (showFileLists != b) {
            showFileLists = b;
            organizePanels();
        }
    }

    /**
     * Re-organize the panels and split panes accoring to the 
     * showFileLists property. This method must only be called
     * when the property changes - it assumes that the panels
     * are in the "other" configuration and rearranges them according
     * to the showFileLists property.
     * 
     * showFileLists == true:
     *     splitPane:
     *         top: tree widget panel...
     *         botton: lowerSplitPane
     *                         top: fileList panel
     *                         bottom: detail panel
     * 
     * showFileLists == false:
     *     splitPane:
     *         top: tree widget panel...
     *         bottom: detail panel
     *     
     */
    private void organizePanels() {
        if (isShowFileLists()) {
            Component detail = splitPane.getBottomComponent();
            splitPane.remove(detail);
            splitPane.setBottomComponent(lowerSplitPane);
            lowerSplitPane.setBottomComponent(detail);
        } else {
            Component detail = lowerSplitPane.getBottomComponent();
            lowerSplitPane.remove(detail);
            splitPane.remove(lowerSplitPane);
            splitPane.setBottomComponent(detail);
        }
    }

    /**
     * Component to prompt for password.
     */
    class PasswordPrompt implements PasswordSource {

        private String password = null;
        private Component dialogParent = null;

        PasswordPrompt(Component comp) {
            dialogParent = comp;
        }

        /**
         * Prompt the user for a password, the userName is displayed to identify
         * the user name for which the password if required. If the user enters          * nothing or presses Cancel, null is returned.
         */
        public String getPassword(
            String userInfo,
            String message,
            String prop) {
            if (password != null) {
                return password;
            } else {
                password = popupPasswordPrompt(userInfo, message, prop);
                return password;
            }
        }

        /**
         * guaranteed to return non null
         */
        public String popupPasswordPrompt(
            String userInfo,
            String message,
            String prop) {
            String tmpPassword = null;
            if (dialogParent != null) {
                //  ( password == null || password.equals("") ) &&
                JPanel panel = new JPanel(new BorderLayout());
                JPasswordField passwordField = new JPasswordField(25);
                panel.add(new JLabel("user: " + userInfo), "North");
                panel.add(passwordField, "South");
                if (JOptionPane
                    .showConfirmDialog(
                        dialogParent,
                        panel,
                        message,
                        JOptionPane.OK_CANCEL_OPTION)
                    == JOptionPane.OK_OPTION) {
                    tmpPassword = new String(passwordField.getPassword());
                }
            }
            if (tmpPassword == null) {
                tmpPassword = new String("");
                GasProp.getProperties().put(prop, "false");
            }
            return tmpPassword;
        }

    }

    /**
     * The DisplayOrganizer responds to user selections and displays
     * the selected file in the Detail Panel.
     */
    class DisplayOrganizer
        implements TreeSelectionListener, ListSelectionListener {

        private Vector[] lists = null;
        private Vector rawFileList = null;
        private Vector masterCalibFileList = null;
        private Vector rbFileList = null;
        private Vector productFileList = null;
        private TreePath lastSelectedPath = null;
        private DBOBComponent selectedDbComponent = null;
        private boolean noProcess = false;

        public DisplayOrganizer() {
            lists = new Vector[4];
            rawFileList = new Vector();
            lists[0] = rawFileList;
            masterCalibFileList = new Vector();
            lists[1] = masterCalibFileList;
            rbFileList = new Vector();
            lists[2] = rbFileList;
            productFileList = new Vector();
            lists[3] = productFileList;
        }

        /**
         * implement the TreeSelectionListener interface.
         */
        public void valueChanged(TreeSelectionEvent evt) {
            Object node = null;
            OBComponent obc = null;
            DBOBComponent dbobc = null;
            ResultsComponent resobc = null;
            TreePath tp = null;

            if (fsSelected) {
                if (noProcess) {
                    noProcess = false;
                    return;
                }

                tp = fsTree.getTree().getSelectionPath();
            }
            if (dbSelected) {
                tp = dbTree.getTree().getSelectionPath();
            }

            if (resSelected) {
                tp = resTree.getTree().getSelectionPath();
            }

            if (tp != null
                && (lastSelectedPath == null || !tp.equals(lastSelectedPath))) {
                node = tp.getLastPathComponent();
                lastSelectedPath = tp;
            }

            if (node == null
                || ((node instanceof OBComponent == false) && fsSelected)
                || ((node instanceof DBOBComponent == false) && dbSelected)
                || ((node instanceof ResultsComponent == false) && resSelected)) {
                return;
            }
            // empty the file lists.
            rawFileList.removeAllElements();
            masterCalibFileList.removeAllElements();
            rbFileList.removeAllElements();
            productFileList.removeAllElements();

            if (selectedDbComponent != null) {
                selectedDbComponent.freeHeaderMemory();
            }
            if (fsSelected) {
                Vector[] boldFaceFonts =
                    { new Vector(), new Vector(), new Vector(), new Vector()};
                obc = (OBComponent) node;

                // fill the file lists with the selected files.
                dataModel.getAssociatedFiles(
                    obc,
                    rawFileList,
                    masterCalibFileList,
                    rbFileList,
                    productFileList);
                // add the lists to our fileLists.
                // The displayLists() call must preceed the
                // showComponentDetail() or the Tree selection will be 
                // over ridden by a List selection.
                fileListPane.setActiveElements(boldFaceFonts);
                displayLists();

                showComponentDetail(obc);
                selectedDbComponent = null;
            }
            if (dbSelected) {
                dbobc = (DBOBComponent) node;
                showComponentDetail(dbobc);
                selectedDbComponent = dbobc;
            }
            if (resSelected) {
                resobc = (ResultsComponent) node;
                showComponentDetail(resobc);
            }
        }

        /**
         * Display the file lists in the middle panel.
         */
        private void displayLists() {
            for (int i = 0; i < tabLabels.length; i++) {
                FileListModel lm =
                    new FileListModel(
                        lists[i],
                        tabLabels[i],
                        emptyListLabels[i]);
                fileListPane.setListModel(lm, i);
            }
        }

        public void clearTreeSelection() {
            fsTree.clearSelection();
            lastSelectedPath = null;
        }

        /**
         * implement the ListSelectionListener interface.
         */
        public void valueChanged(ListSelectionEvent evt) {
            ReductionBlockCommon rbSelected = null;
            Vector[] boldFaceFonts =
                { new Vector(), new Vector(), new Vector(), new Vector()};
            if (!evt.getValueIsAdjusting()) {
                int listSize = 0;
                JList selectedList = (JList) evt.getSource();
                int index = selectedList.getLeadSelectionIndex();
                if (selectedList.isSelectedIndex(index)) {
                    OBComponent obc = null;
                    String fileSelected =
                        (String) selectedList.getModel().getElementAt(index);
                    listSize = selectedList.getModel().getSize();
                    obc = dataModel.getObComponentByArcname(fileSelected);
                    if (obc == null) {
                        obc = new NotFoundOBComponent(fileSelected);

                        if (fileSelected
                            .startsWith("Virtual Reduction Block")) {
                            String triggerName = null;
                            VirtualReductionBlockOBComponent vrbobc = null;
                            try {
                                triggerName =
                                    fileSelected.substring(
                                        fileSelected.indexOf("(") + 1,
                                        fileSelected.lastIndexOf(")"));
                                //System.out.println("it's a virtual reduction block "+ triggerName );
                                if ((vrbobc =
                                    dataModel.getAssociatedVRB(triggerName))
                                    != null) {
                                    //System.out.println("and it exists");
                                    obc = vrbobc;
                                }
                                rbSelected = vrbobc;
                            } catch (StringIndexOutOfBoundsException e) {

                            }
                        }
                    } else {
                        noProcess = true;
                        treeControlPanel.searchTree(
                            DFSFile.getFileName(obc.getId()));

                        if (obc instanceof ReductionBlockOBComponent) {
                            rbSelected = (ReductionBlockCommon) obc;
                        }
                    }
                    if (rbSelected != null && listSize > 1) {
                        Enumeration e = null;
                        e = rbSelected.getProductFileNames().elements();
                        for (; e.hasMoreElements();) {
                            boldFaceFonts[3].addElement(e.nextElement());
                        }
                        e = rbSelected.getMasterCalibFileNames().elements();
                        for (; e.hasMoreElements();) {
                            boldFaceFonts[1].addElement(e.nextElement());
                        }
                        e = rbSelected.getInputFileNames().elements();
                        for (; e.hasMoreElements();) {
                            boldFaceFonts[0].addElement(e.nextElement());
                        }

                    }

                    showComponentDetail(obc);

                    // Notify the FileListPane that some
                    // JList elements should be printed in Boldface
                    fileListPane.setActiveElements(boldFaceFonts);
                }
            }
        }

        /**
         * Set the detail panel with the given OBComponent.
         * @param obc
         */
        public void showComponentDetail(OBComponent obc) {
            setDetailComponent(obc.getDisplayComponent());
        }

        /**
         * Set the detail panel with the given DBOBComponent.
         * @param dbobc
         */
        public void showComponentDetail(DBOBComponent dbobc) {
            dbDataModel.selectSingleFrame(dbobc);
            setDetailComponent(dbobc.getDisplayComponent());
        }

        /**
         * Set the detail panel with the given ResultsComponent.
         * @param resobc
         */
        public void showComponentDetail(ResultsComponent resobc) {
            setDetailComponent(resobc.getDisplayComponent());
        }
    }
}
