/**
 * @author N. Kornweibel
 * @version 1.0
 * The equivalence (=) binary expression.
 */

package org.eso.gasgano.keyword;

import java.util.Enumeration;

public class EqKeywordExpr extends BinaryKeywordExpr {


    static final long serialVersionUID = -1502518046163546511L;
    
    
    public static final String opString = "=";
    /**
     * @param l The left hand value.
     * @param r The right hand value.
     */
    public EqKeywordExpr(Object l, Object r) {
        super(l, r);
    }

    public boolean eval(float l, float r) {
        return (l == r);
    }
 
    public boolean eval(String l, String r) {
        return l.equals(r);
    }

    public String getOpString() {
        return opString;
    }
    /**
     * @see org.eso.gasgano.keyword.DefaultBoolKeywordExpr#copy()
     */
    public DefaultBoolKeywordExpr copy() {
        DefaultBoolKeywordExpr rc = new EqKeywordExpr(getLeftValue(), getRightValue());
        return rc;
    }
}
