/**
 * @author N. Kornweibel
 * @version 1.0
 * The greater than (LT) (>) binary expression.
 */

package org.eso.gasgano.keyword;

public class GTKeywordExpr extends BinaryKeywordExpr {

    static final long serialVersionUID = 590429694886685600L;
    
    public static final String opString = ">";

    /**
     * @param l The left hand value.
     * @param r The right hand value.
     */
    public GTKeywordExpr(Object l, Object r) {
        super(l, r);
    }

    public boolean eval(float l, float r) {
        return (l > r);
    }
 
    public boolean eval(String l, String r) {
        return (l.compareTo(r) > 0);
    }
 
    public String getOpString() {
        return opString;
    }
    /**
     * @see org.eso.gasgano.keyword.DefaultBoolKeywordExpr#copy()
     */
    public DefaultBoolKeywordExpr copy() {
        DefaultBoolKeywordExpr rc = new GTKeywordExpr(getLeftValue(), getRightValue());
        return rc;
    }
}
