/**
 * @author N. Kornweibel
 * @version 1.0
 * The KeywordSet interface - defines the interface to a set of
 * Keywords which can be used in Keyword expressions.
 */

package org.eso.gasgano.keyword;

public interface KeywordSet {

    /**
     * @param k The Keyword to be added to the set.
     */
    public void addKeyword(Keyword k);

    /**
     * @param name The name of the String to be located.
     * @return The Keyword located, or null if not located.
     */
    public Keyword getKeyword(String name);

    /**
     * @param The name of the Keyword to be removed from the set.
     */
    public void removeKeyword(String name);
    
    /**
     * Place this keyword into the position of the current keyword of the
     * same name.
     * @param k
     */
    public void replaceKeyword(Keyword k);

}

// end of file KeywordSet.java
