/**
 * @author N. Kornweibel
 * @version 1.0
 * The less than or equal (LE) (<=) binary expression.
 */

package org.eso.gasgano.keyword;

public class LEKeywordExpr extends BinaryKeywordExpr {

    static final long serialVersionUID = 6996041885820980144L;
    
    public static final String opString = "<=";

    /**
     * @param l The left hand value.
     * @param r The right hand value.
     */
    public LEKeywordExpr(Object l, Object r) {
        super(l, r);
    }

    public boolean eval(float l, float r) {
        return (l <= r);
    }
 
    public boolean eval(String l, String r) {
        return (l.compareTo(r) < 0);
    }
 
    public String getOpString() {
        return opString;
    }
    /**
     * @see org.eso.gasgano.keyword.DefaultBoolKeywordExpr#copy()
     */
    public DefaultBoolKeywordExpr copy() {
        DefaultBoolKeywordExpr rc = new LEKeywordExpr(getLeftValue(), getRightValue());
        return rc;
    }
}
