package org.eso.gasgano.properties;

/**
 * Editable table model used for defining structured properties in
 * the GasPropEditor.
 * 
 * @author Nick Kornweibel
 */

import javax.swing.table.AbstractTableModel;

public abstract class PropertyTableModel extends AbstractTableModel {

    private boolean debug;
    
    /**
     * Remove the specified row from the table.
     * @param rowNum
     */
    public abstract void removeRow(int rowNum);

    /**
     * Insert a (blank) row before the specified row.
     * @param rowNum
     */
    public abstract void insertRow(int rowNum);
    
    /**
     * Returns the debug.
     * @return boolean
     */
    public boolean isDebug() {
        return debug;
    }

    /**
     * Sets the debug.
     * @param debug The debug to set
     */
    public void setDebug(boolean debug) {
        this.debug = debug;
    }

    /**
     * @see javax.swing.table.AbstractTableModel#fireTableDataChanged()
     */
    public void fireTableDataChanged() {
        super.fireTableDataChanged();
    }

    /**
     * @see javax.swing.table.TableModel#getColumnCount()
     */
    public int getColumnCount() {
        return 0;
    }

    /**
     * @see javax.swing.table.TableModel#getRowCount()
     */
    public int getRowCount() {
        return 0;
    }

    /**
     * @see javax.swing.table.TableModel#getValueAt(int, int)
     */
    public Object getValueAt(int rowIndex, int columnIndex) {
        return null;
    }

}
