package org.eso.cpl.gui; 

import java.util.EventListener;

/**
 * Interface for objects that wish to be informed when a 
 * {@link RequestExecutor} does something interesting.
 *
 * @author   Mark Taylor
 */
public interface ExecutionListener extends EventListener {

    /**
     * Invoked when a RequestExecutor has embarked on execution of a recipe.
     *
     * @param  evt  evnt describing the circumstances of the execution
     */
    void executionStarted(ExecutionEvent evt);

    /**
     * Invoked when a RequestExecutor has ceased executing a recipe for 
     * whatever reason.
     *
     * @param  evt  event describing the circumstances of the execution
     */
    void executionEnded(ExecutionEvent evt);
}
