package org.eso.cpl.test;

import javax.swing.JFrame;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.eso.cpl.CPLException;
import org.eso.cpl.FrameList;
import org.eso.cpl.Recipe;
import org.eso.cpl.RecipeLibrary;
import org.eso.cpl.gui.RecipeSelector;
import org.eso.cpl.jni.LTDLException;

/**
 * Test.
 * <p>
 * $Id: GUITest.java,v 1.12 2008/10/01 15:49:11 mpadovan Exp $
 * @author   Mark Taylor
 */
public class GUITest extends TestCase {

    private RecipeLibrary[] libs;

    public GUITest(String name) {
        super(name);
    }

    public void setUp() throws LTDLException, CPLException {
        RecipeLibrary lib1 = JNICPLTest.getGiraffeLibrary();
        RecipeLibrary lib2 = PluginLibraryTest.getTestLibrary();
        RecipeLibrary lib3 = new TestLibrary();
        libs = new RecipeLibrary[] { lib1, lib2, lib3, };
    }

    public void testSelector() {
        final JFrame frame = new JFrame();
        RecipeSelector rsel = new RecipeSelector(libs) {
            protected void approveSelection() {
                Recipe recipe = getSelectedRecipe();
                frame.dispose();
                try {
                    FrameList frames = JNICPLTest.getMasterBiasInputFrames();
                    //showExecutionPanel(recipe, frames);
                }
                catch (Exception e) {
                    e.printStackTrace();
                }
            }
            protected void cancelSelection() {
                System.out.println("Selection cancelled.");
                frame.dispose();
            }
        };
        frame.getContentPane().add(rsel);
        frame.pack();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }
    
    /*

    public void showExecutionPanel(Recipe recipe, FrameList inFrames)
            throws CPLException, LTDLException {
        final JFrame frame = new JFrame();
        ExecutionPanel ep = new ExecutionPanel(recipe, inFrames) {
            public void doClose() {
                frame.dispose();
            }
        };
        ep.setLibraryLoader(new LibraryLoader());
        frame.getContentPane().add(ep);
        frame.pack();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }
*/
    public static TestSuite suite() {
        return new TestSuite(GUITest.class);
    }

    public static void main(String[] args) {
        GUITest t = new GUITest("hi");
        try {
            t.setUp();
            System.out.println("SETUP OK");
        } catch (Exception e) {
            System.out.println("SETUP ERROR : " + e.getMessage() + "\n");
			e.printStackTrace();
		}
        t.testSelector();
        //TestRunner.run(suite());
    }
}
